#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ostream>
#define FAST_ALLOCATOR_MEMORY 5e5
 #ifdef FAST_ALLOCATOR_MEMORY
     int allocator_pos = 0;
     char allocator_memory[(int)FAST_ALLOCATOR_MEMORY];
     inline void * operator new ( size_t n ) {
         char *res = allocator_memory + allocator_pos;
         allocator_pos += n;
         assert(allocator_pos <= (int)FAST_ALLOCATOR_MEMORY);
         return (void *)res;
     }
     inline void operator delete ( void * ) noexcept { }
     //inline void * operator new [] ( size_t ) { assert(0); }
     //inline void operator delete [] ( void * ) { assert(0); }
 #endif

using namespace std;
using ll = long long;


#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()

#define TMAX(type) numeric_limits<type>::max()
#define TMIN(type) numeric_limits<type>::min()
#ifdef LOCAL
#define ass(X) assert(X)
#else
#define ass(X) {}
#endif

#define int long long

const int N = 1e5;

int n, w;
struct Item {
    int w, c, i;
} arr[N];

mt19937 rnd('l'+ 'l' + 'K');
int solve() {
    if (!(cin >> n >> w))
        return 1;
    int old_w = w;
    w = 3LL * w / 2;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].w >> arr[i].c;
        arr[i].i = i;
    }
    sort(arr, arr + n, [](Item q, Item w) { return make_pair(q.c, -q.w) > make_pair(w.c, -w.w); });
    vector<int> ans;
    int cur = 0, cur_c = 0;
    int bc = -1, bi = -1;
    for (int i = 0; i < n; ++i) {
        if (arr[i].w >= old_w && arr[i].w <= w) {
            if (bc < arr[i].c) {
                bc = arr[i].c;
                bi = arr[i].i;
            }
        } else if (cur + arr[i].w <= w) {
            cur += arr[i].w;
            cur_c += arr[i].c;
            ans.push_back(arr[i].i);
        }
    }
    if (cur_c < bc) {
        ans = {bi};
        cur_c = bc;
    }
    vector<int> now_v;
    for (int i = 0; i < 600; i++){
        int now = 0;
        int now_w = 0;
        shuffle(arr, arr + n, rnd);
        now_v.clear();
        for (int j = 0; j < n; j++){
            if (now_w + arr[j].w <= w && arr[j].w <= old_w){
                now += arr[j].c;
                now_w += arr[j].w;
                now_v.push_back(arr[j].i);
            }
        }
        if (now > cur_c){
            cur_c = now;
            ans = now_v;
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
    return 0;
}

signed main() {
#ifdef LOCAL
    freopen("l.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1e9;
    cin >> tests;
    for (int i = 1; i <= tests; i++) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "------------------------------\n";
#endif
    }
}
