#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>


//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline")
//#pragma GCC optimize("-fgcse")
//#pragma GCC optimize("-fgcse-lm")
//#pragma GCC optimize("-fipa-sra")
//#pragma GCC optimize("-ftree-pre")
//#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-ffast-math")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-falign-jumps")
//#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-funroll-loops")
//#pragma GCC optimize("-fwhole-program")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-fstrict-overflow")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-skip-blocks")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("-funsafe-loop-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")


#define ull unsigned long long
#define pll pair<ll, ll>
#define mp make_pair
#define ll long long
#define ld long double
#define i128 ll
#define pb push_back
#define deb(x) cout << #x << " = " << x << endl
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<ll>
#define vvi vector<vi>
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define f first
#define s second
typedef std::complex<ld> cmpl;



const ll mod1 = 1e9 + 7;
const ll mod2 = 998244353;
const ll P1 = 678463;
const ll P2 = 239;
const ll inf = (ll)1e18;
const long double MATH_E = 2.718281828459;
const long double eps = 1e-9;
const long double MATH_PI = atan2l(0, -1);
const ll MAXN = 1e5 + 1;


using namespace std;
//using namespace __gnu_pbds;


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    std::uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


struct el {
    ll w, c, ind;
};


ll calcDp(const vector<pll> &arr, ll w) {
    vector<ll> dp(w + 1, -inf);
    dp[0] = 0;
    for (auto p : arr) {
        for (int i = w; i > 0; i--) {
            if (i >= p.first)
                dp[i] = max(dp[i], dp[i - p.first] + p.second);
        }
    }
    return *max_element(all(dp));
}


pair<ll, vector<int>> calcGreed1(const vector<el> &arr, ll w) {
    vector<el> a = arr;
    sort(all(a), [&](el x, el y) {
        if (x.c == y.c) {
            return x.w < y.w;
        }
        return x.c > y.c;
    });
    ll have = w;
    ll ans = 0;
    vector<int> kek;
    for (auto p : a) {
        if (p.w <= have) {
            ans += p.c;
            have -= p.w;
            kek.pb(p.ind);
        }
    }
    return {ans, kek};
}


pair<ll, vector<int>> greed2(const vector<el> &arr, ll w) {
    vector<el> a = arr;
    sort(all(a), [&](el x, el y) {
        return (x.c * y.w > y.c * x.w);
    });
    ll have = w;
    ll ans = 0;
    vector<int> res;
    for (auto p : a) {
        if (p.w <= have) {
            ans += p.c;
            have -= p.w;
            res.pb(p.ind);
        }
    }
    return {ans, res};
}


void solve() {
    ll n, w;
    cin >> n >> w;
    vector<el> lol(n);
    for (int i = 0; i < n; i++) {
        cin >> lol[i].w >> lol[i].c;
        lol[i].ind = i + 1;
    }
    auto g1 = greed2(lol, 3 * w / 2);
    auto g2 = calcGreed1(lol, 3 * w / 2);
    if (g1.first > g2.first) {
        cout << g1.second.size() << "\n";
        for (auto i : g1.second) {
            cout << i << " ";
        }
        cout << "\n";
    } else {
        cout << g2.second.size() << "\n";
        for (auto i : g2.second) {
            cout << i << " ";
        }
        cout << "\n";

    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout.precision(30);
    srand(time(0));
    cout.setf(ios::fixed);

    ll t;
    cin >> t;
//    while (t--) {
//        ll n = rnd(1, 30);
//        ll w = rnd(1, 1000);
//        vector<pll> arr(n);
//        for (int i = 0; i < n; i++) {
//            arr[i].first = rnd(1, 100);
//            arr[i].second = rnd(1, 100);
//        }
//        ll correct = calcDp(arr, w);
//        ll lol = calcGreed1(arr, w * 3 / 2);
//        ll lol1 = greed2(arr, w * 3 / 2);
//        if (correct > max(lol, lol1)) {
//            cout << "Bad test found:" << "\n";
//            cout << n << " " << w << "\n";
//            for (auto p : arr) {
//                cout << p.first << " " << p.second << "\n";
//            }
//            cout << "Correct = " << correct << " but found " << max(lol, lol1);
//            break;
//        } else {
//            cerr << "Ok test" << endl;
//        }
//    }
    while (t--)
        solve();
    return 0;
}