#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;

using ll = long long;
using ld = long double;

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	ll n, k1;
	cin >> n >> k1;

	vector<vector<int>> dp(n + 1, vector<int> (n + 1));
	dp[0][0] = 1;
	vector<int> st(6);
	st[0] = 1;
	for (int i = 1; i < 6; ++i)
		st[i] = st[i - 1] * k1;

	vector<vector<int>> c(40, vector<int> (40));

	c[0][0] = 1;
	for (int i = 1; i < 40; ++i) {
		c[i][0] = 1;
		c[i][i] = 1;
		for (int j = 1; j < i; ++j)
			c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
	}

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			for (int k = 1; k * j <= i; ++k)
				for (int m = 0; m < j; ++m) {
					dp[i][j] += dp[i - k * j][m] * c[k + k1 - 1][k1 - 1];
				}

	ll sum = 0;
	for (int i = 0; i <= n; ++i)
		sum += dp[n][i];

	cout << sum;
	return 0;
}