#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair 
#define pb push_back 

#include <iostream>
#include <algorithm>
#include <math.h>
#include <stack>
#include <vector>
#include <queue>
#include <iomanip>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 2e5 + 1;
const int alp = 30;
const ll inf = 1e9 + 10;
const int mod = 1e9 + 7;

int a[maxn];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen("notepad.in", "r", stdin);
	//freopen("notepad.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, s, m;

	cin >> n >> m >> s;

	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
	}

	sort(a + 1, a + (m + 1));
	int sz = unique(a + 1, a + (m + 1)) - (a + 1);

	int l = 1, r = m;

	int cnt = 0, ans = 0;

	for (int i = 1; i <= sz; ++i) {
		if (a[i] >= l && a[i] <= r)
			++cnt;
	}

	if (s + cnt >= m) {
		++ans;
	}

	if (a[1] == 1) {
		--cnt;
	}
	for (int i = 1; i <= sz; ++i) {
		if (a[i] == m + 1) {
			++cnt;
			break;
		}
	}



	while (true) {
		int indl = lower_bound(a + 1, a + (m + 1), l + 1) - a;
		int indr = lower_bound(a + 1, a + (m + 1), r + 1) - a;
		int xl, xr;
		if (indl > sz)
			xl = 0;
		else
			xl = a[indl];
		if (indr > sz)
			xr = 0;
		else
			xr = a[indr];
		if (xl == 0 || xr == 0) {
			break;
		}
		if (xl - l < xr - r) {
			if (s + cnt >= m) {
				ans += xl - l;
			}
			r += (xl - l);
			l = xl;
			--cnt;
		}
		else if (xr - r < xl - l) {
			if (s + cnt >= m) {
				ans += xr - 1 - r;
			}
			++cnt;
			if (s + cnt >= m) {
				ans++;
			}
			l += xr - r;
			r = xr;
		}
		else {
			if (s + cnt >= m) {
				ans += xl - l - 1;
			}
			r += xl - l;
			l = xl;
			++cnt;
			if (s + cnt >= m) {
				++ans;
			}
			--cnt;
		}
	}

	while (r != n) {
		int indl = lower_bound(a + 1, a + (m + 1), l + 1) - a;
		int xl;
		if (indl > sz) {
			if (s + cnt >= m) {
				ans += n - r;
			}
			cout << ans;
			return 0;
		}
		else
			xl = a[indl];
		if (s + cnt >= m) {
			ans += xl - l;
		}
		r += (xl - l);
		l = xl;
		--cnt;
	}


	cout << ans;

}