#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair 
#define pb push_back 

#include <iostream>
#include <algorithm>
#include <math.h>
#include <stack>
#include <vector>
#include <queue>
#include <iomanip>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 2e5 + 1;
const int alp = 30;
const ll inf = 1e9 + 10;
const int mod = 1e9 + 7;

int a[maxn];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen("notepad.in", "r", stdin);
	//freopen("notepad.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, s, m;

	cin >> n >> m >> s;

	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
	}

	sort(a + 1, a + (m + 1));
	int sz = unique(a + 1, a + (m + 1)) - (a + 1);

	int l = 1, r = m;

	int cnt = 0, ans = 0;

	for (int i = 1; i <= sz; ++i) {
		if (a[i] >= l && a[i] <= r)
			++cnt;
	}

	while (true) {
		int indl = lower_bound(a + 1, a + (sz + 1), l) - a;
		int indr = lower_bound(a + 1, a + (sz + 1), r + 1) - a;

		if (indr > sz)
			break;
		
		bool c = false;
		int scnt = cnt;

		if (a[indl] == l) {
			--cnt;
			c = true;
		}
		if (a[indr] == r + 1) {
			cnt++;
			c = true;
		}
		if (c) {
			if (scnt + s >= m) {
				++ans;
			}
			++l, ++r;
			continue;
		}

		if (a[indl] - l < a[indr] - 1 - r) {
			if (cnt + s >= m) {
				ans += a[indl] - l;
			}
			r += a[indl] - l;
			l = a[indl];
		}
		else if (a[indl] - l > a[indr] - 1 - r) {
			if (cnt + s >= m) {
				ans += (a[indr] - 1) - r;
			}
			l += (a[indr] - 1) - r;
			r = a[indr] - 1;
		}
		else {
			if (cnt + s >= m) {
				ans += a[indl] - l;
			}
			r += a[indl] - l;
			l = a[indl];
		}
		

	}

	while (r != n + 1) {

		int indl = lower_bound(a + 1, a + (sz + 1), l) - a;

		if (indl > sz) {
			if (cnt + s >= m) {
				ans += (n + 1) - r;
			}
			cout << ans;
			return 0;
		}


		bool c = false;
		int scnt = cnt;

		if (a[indl] == l) {
			--cnt;
			c = true;
		}
		if (c) {
			if (scnt + s >= m) {
				++ans;
			}
			++l, ++r;
			continue;
		}

		int xl = min(a[indl], n - m + 2);

		if (cnt + s >= m) {
			ans += xl - l;
		}
		r += xl - l;
		l = xl;
	}


	cout << ans;

}