#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <bitset>
#include <queue>
#include <map>
#include <random>
#include <queue>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()
#define fi first
#define se second
#define pb emplace_back
#define ld long double

#define ALG
//#define MINT
//#define GEOM

#ifdef ALG
namespace alg_space
{
	template<class T>
	T sqr(T a)
	{
		return a * a;
	}

	template<class T>
	T gcd(T a, T b)
	{
		while (b != 0)
		{
			a %= b;
			swap(a, b);
		}
		return a;
	}
}

using namespace alg_space;
#endif

#ifdef MINT
namespace mint_space
{
#define FACT

#ifdef FACT
	const int MINT_N = 2e5;
#endif
	const int MINT_MOD = 1e9 + 7;

	struct mint
	{
		long long a;
		mint(int b) : a(b) {}
		mint(long long b) : a(b) {}
		mint() : a(0) {}
	};

	istream& operator>>(istream& cin, mint a)
	{
		return cin >> a.a;
	}

	ostream& operator<<(ostream& cout, const mint& a)
	{
		return cout << a.a;
	}

	mint operator+=(mint& a, mint b)
	{
		a.a += b.a;
		if (a.a > MINT_MOD)
		{
			a.a -= MINT_MOD;
		}
		return a;
	}

	mint operator+(mint a, mint b)
	{
		return a += b;
	}

	mint operator-=(mint& a, mint b)
	{
		a.a -= b.a;
		if (a.a < 0)
		{
			a.a += MINT_MOD;
		}
		return a;
	}

	mint operator-(mint a, mint b)
	{
		return a -= b;
	}

	mint operator*=(mint& a, mint b)
	{
		a.a *= b.a;
		a.a %= MINT_MOD;
		return a;
	}

	mint operator*(mint a, mint b)
	{
		return a *= b;
	}

	mint operator^(mint a, int b)
	{
		mint ans = 1;
		mint now = a;
		int i = 1;
		while (true)
		{
			if (i & b)
			{
				ans *= now;
			}
			if (i == (1 << 30))
			{
				break;
			}
			i <<= 1;
			now *= now;
		}
		return ans;
	}

	mint operator/=(mint& a, mint b)
	{
		a *= (b ^ (MINT_MOD - 2));
		return a;
	}

	mint operator/(mint a, mint b)
	{
		return a /= b;
	}

#ifdef FACT
	mint f[MINT_N];
	mint f1[MINT_N];

	void f_count(int n)
	{
		f[0] = 1;
		f1[0] = 1;
		for (int i = 1; i < n; i++)
		{
			f[i] = f[i - 1] * i;
			f1[i] = 1 / f[i];
		}
	}

	mint get_c(int n, int k)
	{
		return f[n] * f1[k] * f1[n - k];
	}

	mint get_a(int n, int k)
	{
		return f[n] * f1[n - k];
	}
#endif
}

using namespace mint_space;
#endif


const int N = 3e5;

vector<vector<int>> v;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	vector<int> now;
	for (int i = 0; i < n; i++)
	{
		now.push_back(1);
	}
	v.push_back(now);
	while (now.size() != 1)
	{
		int sum = now[now.size() - 1] + now[now.size() - 2];
		int kol = now[now.size() - 2] + 1;
		now.pop_back();
		now.pop_back();
		while (sum > 0)
		{
			if (sum >= 2 * kol)
			{
				now.push_back(kol);
				sum -= kol;
			}
			else
			{
				now.push_back(sum);
				sum = 0;
			}
		}
		v.push_back(now);
	}
	ll ans = 0;
	for (int i = 0; i < v.size(); i++)
	{
		int kol = 1;
		ll pr = 1;
		for (int j = 1; j < v[i].size(); j++)
		{
			if (v[i][j] == v[i][j - 1])
			{
				kol++;
			}
			else
			{
				ll nnow = 1;
				for (int u = 1; u <= k - 1; u++)
				{
					nnow *= (kol + u);
				}
				for (int u = 1; u <= k - 1; u++)
				{
					nnow /= u;
				}
				pr *= nnow;
				kol = 1;
			}
		}
		ll nnow = 1;
		for (int u = 1; u <= k - 1; u++)
		{
			nnow *= (kol + u);
		}
		for (int u = 1; u <= k - 1; u++)
		{
			nnow /= u;
		}
		pr *= nnow;
		ans += pr;
	}
	cout << ans;
}