#ifndef ONPC
  #define _FORTIFY_SOURCE 0
  #pragma GCC optimize("Ofast")
  #pragma GCC optimize("no-stack-protector")
  #pragma GCC optimize("unroll-loops")
  #pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
  #pragma GCC optimize("fast-math")
#endif

#include <bits/stdc++.h>

#define mp make_pair
#define eb emplace_back
#define x first
#define y second

template <typename T>
bool chmax(T &a, const T &b) {
    if (a < b) {
      a = b;
        return true;
    }
    return false;
}

template <typename T>
bool chmin(T &a, const T &b) {
    if (a > b) {
      a = b;
      return true;
    }
    return false;
}

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

#ifdef ONPC
mt19937 rnd(228);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 998244353LL;
const ld PI = acos(-1);

const int MAXN = 100;
//#define int long long
const int INF = 1e9;

void solve(){
  int n, m, s;
  cin >> n >> m >> s;
  vector<int> b(m);
  set<int> st;
  for (int i = 0; i < m; i++){
    cin >> b[i];
    st.insert(b[i]);
  }

  vector<int> a;
  for (int i : st) a.eb(i);
  sort(begin(a), end(a));
  int N = a.size();

  int left = 0;
  int ans = 0;
  int imax = n - m + 1;
  //cerr << imax << '\n';
  for (int i = 0; i < N; i++){
    int to = i + m - s - 1;
    if (to >= N) break;
    int dist = a[to] - a[i] + 1;
    int go = m - dist;
    int lp = max(left + 1, i - go);
    ans += max(0, (min(imax, a[i]) - lp + 1));
    //cerr << a[i] << ' ' << a[to] << ' ' << dist << ' ' << go << ' ' << lp << '\n';
    left = a[i];
  }

  cout << ans << '\n';
}

/*
#ifndef ONPC
#define FILEIO
#endif
*/
signed main()
{
    #ifdef FILEIO
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
