#define _USE_MATH_DEFINES
// #pragma GCC optimize(3)
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
// #pragma GCC optimize("vpt")
// #pragma GCC optimize("rename-registers")
// #pragma GCC optimize("move-loop-invariants")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC optimize("function-sections")
// #pragma GCC optimize("data-sections")
// #pragma GCC optimize("branch-target-load-optimize")
// #pragma GCC optimize("branch-target-load-optimize2")
// #pragma GCC optimize("btr-bb-exclusive")
// #pragma GCC optimize("inline")
// #pragma GCC optimize("-fgcse")
// #pragma GCC optimize("-fgcse-lm")
// #pragma GCC optimize("-fipa-sra")
// #pragma GCC optimize("-ftree-pre")
// #pragma GCC optimize("-ftree-vrp")
// #pragma GCC optimize("-fpeephole2")
// #pragma GCC optimize("-ffast-math")
// #pragma GCC optimize("-fsched-spec")
// #pragma GCC optimize("-falign-jumps")
// #pragma GCC optimize("-falign-loops")
// #pragma GCC optimize("-falign-labels")
// #pragma GCC optimize("-fdevirtualize")
// #pragma GCC optimize("-fcaller-saves")
// #pragma GCC optimize("-fcrossjumping")
// #pragma GCC optimize("-fthread-jumps")
// #pragma GCC optimize("-freorder-blocks")
// #pragma GCC optimize("-fschedule-insns")
// #pragma GCC optimize("inline-functions")
// #pragma GCC optimize("-ftree-tail-merge")
// #pragma GCC optimize("-fschedule-insns2")
// #pragma GCC optimize("-fstrict-aliasing")
// #pragma GCC optimize("-falign-functions")
// #pragma GCC optimize("-fcse-follow-jumps")
// #pragma GCC optimize("-fsched-interblock")
// #pragma GCC optimize("-fpartial-inlining")
// #pragma GCC optimize("no-stack-protector")
// #pragma GCC optimize("-freorder-functions")
// #pragma GCC optimize("-findirect-inlining")
// #pragma GCC optimize("-fhoist-adjacent-loads")
// #pragma GCC optimize("-frerun-cse-after-loop")
// #pragma GCC optimize("inline-small-functions")
// #pragma GCC optimize("-finline-small-functions")
// #pragma GCC optimize("-ftree-switch-conversion")
// #pragma GCC optimize("-foptimize-sibling-calls")
// #pragma GCC optimize("-fexpensive-optimizations")
// #pragma GCC optimize("inline-functions-called-once")
// #pragma GCC optimize("-fdelete-null-pointer-checks")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#ifdef DEBUG
    #define debug(x) std::cerr << #x << ": " << x << '\n'
#else
    #define debug(x) ;
#endif
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

const int MAXC = 30;
#ifdef DEBUG
    const int MAXN = 15;
    const int MAXM = 10;
#else
    const int MAXN = 1e3 + 5;
    const int MAXM = 1e3 + 5;
#endif

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io; 
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(15) << std::fixed;
    long double START_TIME = clock();

    int n, m, s;
    std::cin >> n >> m >> s;
    std::vector<int> a(m);
    for(auto &i : a) std::cin >> i;
    std::sort(all(a));
    a.erase(std::unique(all(a)), a.end());
    std::map<int, int> have;
    m = a.size();
    int ans = 0;
    for(int i = 0; i < a.size(); i++) {
        // start on i
        int l = a[i];
        int r = a[i] + m - 1;
        while(true || r > n) {
            if(have.count(l)) break;
            auto it1 = std::lower_bound(all(a), l) - a.begin();
            auto it2 = std::lower_bound(all(a), r) - a.begin();
            int cntNeed = 0;
            if(it2 != m) {
                cntNeed = m;
                cntNeed -= it2 - it1 + (a[it2] == r);
                if(cntNeed > s) break;
                have[l] = 1;
                debug(l);
                // debug(r);
                ans++;
            }
            else {
                cntNeed = m;
                cntNeed -= it2 - it1;
                if(cntNeed > s) break;
                have[l] = 1;
                debug(l);
                // debug(r);
                ans++;
            }
            l++;
            r++;
        }
        l = a[i] - 1;
        r = a[i] + m - 2;
        while(true) {
            if(have.count(l) || l <= 0) break;
            auto it1 = std::lower_bound(all(a), l) - a.begin();
            auto it2 = std::lower_bound(all(a), r) - a.begin();
            int cntNeed = 0;
            if(it2 != m) {
                cntNeed = m;
                cntNeed -= it2 - it1 + (a[it2] == r);
                if(cntNeed > s) break;
                have[l] = 1;
                debug(l);
                ans++;
            }
            else {
                cntNeed = m;
                cntNeed -= it2 - it1;
                if(cntNeed > s) break;
                have[l] = 1;
                debug(l);
                // debug(r);
                ans++;
            }
            l--;
            r--;
        }
    }
    std::cout << ans << '\n';

    #ifdef DEBUG
        long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
        debug(TIME);
    #endif
    return 0;
}
