#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

vector <int> cnt(16, 0);
vector <vector <int>> ans;

void dfs(int v, int p = -1){
    if(v == 0){
        ans.push_back(cnt);
    }
    else{
        for(int i = 1; i <= v; ++i){
            if(i >= p - v) {
                ++cnt[i];
                dfs(v - i, v);
            }
        }
    }
    if(p != -1) --cnt[p - v];
}

ll cnk(long double n, long double k){
    long double res = 1;
    for(long double i = 1; i <= k; i += 1){
        res *= (n - k + i) / i;
    }
    return ll(res + 0.02);
}

void solve (){
    int n, k;
    cin >> n >> k;
    dfs(n);
    ll answer = 0;
    for (auto x: ans){
        ll now = 1;
        for (auto s: x){
            if (s != 0){
                now *= cnk(s + k - 1, s);
            }
        }
        answer += now;
    }
    cout << answer << "\n";
}

int32_t main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    solve();
}