#include <bits/stdc++.h>
using namespace std;

//typedef long long ll;

void solve () {
    int n, m, s;
    cin >> n >> m >> s;
    vector <int> a(m + 1, 0);
    for (int i = 1; i <= m; ++i)
        cin >> a[i];
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    map <int, int> cards_before;
    cards_before[a[0]] = 0;
    for (size_t i = 1; i < a.size(); ++i)
        cards_before[a[i]] = cards_before[a[i - 1]] + 1;
    int64_t ans = 0;
    for (size_t i = 1; i <= a.size(); ++i) {
        int l = a[i], r = a[i] + m - 1;
        if (r <= n) {
            if (prev(cards_before.upper_bound(r)) -> second - prev(cards_before.lower_bound(l)) -> second >= m - s)
                ++ans;
        }
        int ll = a[i - 1] + 1, rl = min(a[i] - 1, n - m + 1);
        if (ll <= rl) {
            while (rl - ll > 1) {
                int ml = (ll + rl) / 2;
                if (prev(cards_before.upper_bound(ml + m - 1)) -> second - prev(cards_before.lower_bound(ml)) -> second >= m - s)
                    ll = ml;
                else
                    rl = ml;
            }
            if (prev(cards_before.upper_bound(ll + m - 1)) -> second - prev(cards_before.lower_bound(ll)) -> second >= m - s)
                ans += min(a[i] - 1, n - m + 1) - ll + 1;
            else if (prev(cards_before.upper_bound(rl + m - 1)) -> second - prev(cards_before.lower_bound(rl)) -> second >= m - s)
                ans += min(a[i] - 1, n - m + 1) - rl + 1;
        }
    }
    cout << ans << '\n';
}

int32_t main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    solve();
}