#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <climits>
#include <random>
#include <unordered_set>
#include <queue>
#include <bitset>

using namespace std;

#pragma warning (disable : 4996)

string toBin(int n, int l)
{
    string res;
    while (n > 0)
        res += to_string(n % 2), n /= 2;
    while (res.size() < (1 << l))
        res += '0';
    reverse(res.begin(), res.end());
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef  _DEBUG
    freopen("input.txt", "r", stdin);
#endif 
    int n;
    cin >> n;
    int l = (n - 1) / 2;
    string ans;
    for (int i = 0; i < (1 << (l + 1)); i++)
        ans += toBin(i, l);
    if (n % 2 == 0)
    {
        string s = ans;
        reverse(ans.begin(), ans.end());
        s += ans;
        ans = s;
    }
    cout << ans;
    return 0;
}