#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <climits>
#include <random>
#include <unordered_set>
#include <queue>
#include <bitset>

using namespace std;

#pragma warning (disable : 4996)

string toBin(int n, int l)
{
    string res = "";
    while (n > 0)
        res += to_string(n % 2), n /= 2;
    while (res.size() < l)
        res += '0';
    reverse(res.begin(), res.end());
    return res;
}

bool used[(int)2e6];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef  _DEBUG
    freopen("input.txt", "r", stdin);
#endif 
    int n;
    cin >> n;
    if (n == 1)
    {
        cout << 0;
        return 0;
    }
    int l;
    for (int i = 1; i < n; i *= 2)
        if (i <= (1 << (n - i)))
            l = i;
    string ans;
    for (int i = 0; i < (1 << l); i++)
        ans += toBin(i, l);
    if (ans.size() < (1 << n))
    {
        for (int i = 0; i < (1 << l); i += 2)
            used[(i << l) + i + 1] = 1;
        int cur = 0;
        while (ans.size() < (1 << n))
        {
            while (used[cur])
                cur++;
            ans += toBin(cur, l * 2);
            used[cur] = 1;
        }
    }
    cout << ans;
    return 0;
}