#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <vector>

using namespace std;

#define int int64_t
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 1e18;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, s, m;
	cin >> n >> m >> s;
	vector<int> a;
	set<int> st;
	for (int i = 1, x; i <= m; ++i)
		cin >> x, st.insert(x);
	for (auto t : st)
		a.push_back(t);
	vector<pair<int, int>> scan;
	for (int r = 0, l = 0; r < a.size(); ++r) {
		while (a[r] - a[l] + 1 > m)++l;
		if ((r - l + s + 2 - m) > 0) {
			scan.push_back({ max(a[r]-m,0ll), 1 });
			scan.push_back({ min(a[l]+m,n), -1 });
		}if (r == a.size() - 1) {
			while (l<r) {
				++l;
				if ((r - l + s + 2 - m) > 0) {
					scan.push_back({ max(a[r] - m,0ll), 1 });
					scan.push_back({ min(a[l] + m,n), -1 });
				}
			}
		}
	}
	sort(all(scan), [](pair<int, int> a, pair<int, int> b) {
		if (a.first != b.first)
			return a.first < b.first;
		return a.second > b.second;
	});
	int b = 0;
	int l = -1;
	int ans = 0;
	for (auto e : scan) {
		if (b == 0)l = e.first;
		b += e.second;
		if (b == 0) {
			int r = e.first;
			ans += max(0ll,r - l-m);
		}
	}
	cout << ans << "\n";
	return 0;
}
