#include <functional>
#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = 2e5 + 1;
const ll mod = 1000000007;

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

ll n;

ll w;

vector<pair<pair<ll, ll>, ll>> vc;

bool cmp(pair<pair<ll, ll>, ll> p1, pair<pair<ll, ll>, ll> p2) {
	ll kek = p1.first.first* p2.first.second - p2.first.first * p1.first.second;
	if (kek != 0) return kek < 0;
	return p1.first.second < p2.first.second;
}

void solve() {
	cin >> n >> w;
	w = (w * 3) / 2;
	vc.clear();
	for (ll i = 0; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		vc.push_back({ { b, a }, i + 1 });
	}
	sort(all(vc), cmp);
	vector<ll> ans;
	for (ll i = 0; i < n; i++) {
		if (w >= vc[i].first.second) {
			w -= vc[i].first.second;
			ans.push_back(i);
		}
		else {
			if (ans.empty()) continue;
			if (vc[ans.back()].first.second + w >= vc[i].first.second && vc[i].first.first > vc[ans.back()].first.first) {
				w += vc[ans.back()].first.second;
				w -= vc[i].first.second;
				ans.pop_back();
				ans.push_back(i);
			}
		}
	}
	cout << ans.size() << endl;
	for (ll i : ans) cout << vc[i].second << " ";
}

ll ts = 0;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> ts;
	while (ts--) {
		solve();
		cout << "\n";
	}
	ex();
}