#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

long long rec(long long n, long long last){
    if(n == 0){
        return 1;
    }
    long long ans = 0;
    for(long long i = 1; i <= min(last, n); ++i) {
        ans += rec(n - i, i);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<vector<long long>> dp(n + 1, vector<long long>(k, 0));
    for(int i = 0; i <= n; ++i){
        dp[i][0] = rec(i, i);
    }
    for(int i = 0; i <= n; ++i){
        for(int j = 1; j < k; ++j){
            for(int q = 0; q <= i; ++q){
                dp[i][j] += dp[q][0] * dp[i - q][j - 1];
            }
        }
    }
    cout << dp[n][k - 1];

    return 0;
}