//
// Created by FTSH on 12.12.2020.
//
#include <bits/stdc++.h>
using namespace std;
vector <bool> used;
vector <pair<int, int>> edges;
vector <vector <int>> g;


void dfs(int v){
    used[v] = true;
    for (int i : g[v]){
        if (used[i]) continue;
        edges.emplace_back(v, i);
        dfs(i);
    }
}


int main(){
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i ++){
        int c;
        cin >> c;
    }
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i ++){
        int a, b;
        cin >> a >> b;
        a --; b --;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0);
    vector <int> d(n);
    d[0] = 1;
    for (pair <int, int> i : edges) {
        if (d[i.first] != k){
            d[i.second] = d[i.first] + 1;
        } else {
            d[i.second] = 1;
        }
    }
    for (int i : d){
        cout << i << ' ';
    }
}