#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>
 
using namespace std;
 
typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;
 
 
void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
 
void formatting () {
    cout << fixed;
    cout.precision(3);
    cout << setprecision(2);
}

void solve();
 
int main () {
    acceleration();
    solve();
}
ll const N = 1e6 + 10, mod = 1e9 + 7, INF = 2e9;

ll GCD (ll a, ll b){
    if(!b) return a;
    return GCD(b, a % b);
}

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (binpow(n, k / 2) * binpow(n, k / 2)) % mod;
    else return (n * binpow(n, k - 1)) % mod;
}

void solve () {
    ll n, m = 1, k = 1, l, kol, t;
    cin >> n;
    m = binpow(2, n);
    for(ll i = 0;;i++){
        if(m / binpow(2, i) < i){
            k = i - 1;
            kol = m / binpow(2, k);
            break;
        }
    }
    for(int i = 0; i < binpow(2, k) && i <= m / kol; i++){
        l = i;
        t = binpow(2, kol - 1);
        for(int j = 0; j < kol; j++){
            cout << l / t;
            l %= t;
            t /= 2;
        }
    }
}
