#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const long long one = 1;

int main()
{
    long long n, m, s;
    cin >> n;
    cin >> m;
    cin >> s;
    set<long long> S;
    vector<pair<long long, int> > data(2 * m);
    for (long long i = 0; i < m; ++i) {
        long long x;
        cin >> x;
        if (S.find(x) == S.end()) {
            long long mm = max(x - m + 1, one);
            data[i * 2] = {mm, -1};
            data[i * 2 + 1] = {min(x + 1, n - m + 2), 1};
            S.insert(x);
        }
    }
    sort(data.begin(), data.end());
    /*for (auto i: data) {
        cout << i.first << ' ' << i.second << '\n';
    }*/
    long long cnt = 0;
    long long ans = 0;
    for (long long i = 0; i < 2 * m; ++i) {
        if (cnt + s >= m) {
            ans += data[i].first - data[i - 1].first;
            //cout << data[i].first << ' ';
        }
        cnt -= data[i].second;
    }
    cout << ans;
    return 0;
}
