#include<iostream>
#include<vector>
#include<algorithm>
#include<ctime>
#include<iomanip>

using namespace std;

vector<vector<vector<int>>> ans(16);

long long fact(int n) {
	long long ans = 1;
	for (int i = 2; i <= n; ++i)
		ans *= i;
	return ans;
}

long long C(int n, int k) {
	return fact(n) / fact(k) / fact(n - k);
}

void bruteforce(int summ, int maxx, vector<int>& a, int now) {
	if (summ == 0) {
		ans[now].push_back(a);
		return;
	}
	for (int i = min(maxx, summ); i >= 1; --i) {
		a[i]++;
		bruteforce(summ - i, i, a, now);
		a[i]--;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	for (int i = 1; i <= 15; ++i) {
		vector<int> a(16, 0);
		bruteforce(i, i, a, i);
	}
	int n, k;
	cin >> n >> k;
	long long anss = 0;
	for (auto& a : ans[n]) {
		long long part = 1;
		for (int i = 1; i < 16; ++i) {
			if (a[i] == 0)
				continue;
			long long ppart = 0;
			for (auto& b : ans[k - 1]) {
				int summ = 0;
				for (int kk : b)
					summ += kk;
				ppart += C(a[i] + 1, summ);
			}
			part *= ppart;
		}
		anss += part;
	}
	cout << anss;
}