/*
         ,--"""",--.__,---[],-------._
       ,"   __,'            \         \--""""""==;-
     ," _,-"  "/---.___     \       ___\   ,-'',"
    /,-'      / ;. ,.--'-.__\  _,-"" ,| `,'   /
   /``""""-._/,-|:\       []\,' ```-/:;-. `. /
             `  ;:::      ||       /:,;  `-.\
                =.,'__,---||-.____',.=
                =(:\_     ||__    ):)=
               ,"::::`----||::`--':::"._
             ,':::::::::::||::::::::::::'.
    .__     ;:::.-.:::::__||___:::::.-.:::\     __,
       """-;:::( O )::::>_|| _<::::( O )::::-"""
   =======;:::::`-`:::::::||':::::::`-`:::::\=======
    ,--"";:::_____________||______________::::""----.          , ,
         ; ::`._(    |    |||     |   )_,'::::\_,,,,,,,,,,____/,'_,
       ,;    :::`--._|____[]|_____|_.-'::::::::::::::::::::::::);_
      ;/ /      :::::::::,||,:::::::::::::::::::::::::::::::::::/
     /; ``''''----------/,'/,__,,,,,____:::::::::::::::::::::,"
     ;/                :);/|_;| ,--.. . ```-.:::::::::::::_,"
    /;                :::):__,'//""\\. ,--.. \:::,:::::_,"
   ;/              :::::/ . . . . . . //""\\. \::":__,"
   ;/          :::::::,' . . . . . . . . . . .:`::\
   ';      :::::::__,'. ,--.. . .,--. . . . . .:`::`
   ';   __,..--'''-. . //""\\. .//""\\ . ,--.. :`:::`
   ;    /  \\ .//""\\ . . . . . . . . . //""\\. :`::`
   ;   /       . . . . . . . . . . . . . . . . .:`::`
   ;   (          . . . . . . . . . . . . . . . ;:::`
   ,:  ;,            . . . . . . . . . . . . . ;':::`
   ,:  ;,             . . . . . . . . . . . . .;`:::
   ,:   ;,             . . . . . . . . . . . . ;`::;`
    ,:  ;             . . . . . . . . . . . . ;':::;`
     :   ;             . . . . . . . . . . . ,':::;
      :   '.          . . . . . . . .. . . .,':::;`
       :    `.       . . . . . . . . . . . ;::::;`
        '.    `-.   . . . . . . . . . . ,-'::::;
          `:_    ``--..___________..--'':::::;'`
             `._::,.:,.:,:_ctr_:,:,.::,.:_;'`
________________`"\/"\/\/'""""`\/"\/""\/"____________________________
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <set>
#include <fstream>
#include <climits>
#include <cmath>
#include <deque>
#include <map>
#include <ctime>
#include <random>
#include <unordered_set>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <cassert>
#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back
#define pp pop_back
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define IO ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define out(a) cout << a << " ";
#define in(x) cin >> x;
#define ends cout << endl;
#define here cout << "here" << endl;
using namespace std;

int n;
vector <vector <string>> arr;
unordered_set <string> all;
vector <ll> d;
void rec (int l, string &s) {
    if (s.size() == l) {
        arr[l].pb(s);
        return;
    }
    for (int i = 0; i < 2; i++) {
        char a = i + '0';
        s += a;
        rec(l, s);
        s.pop_back();
    }
}

void pl (ll l, string &s) {
    if (l == d[2] * 2) {
        for (int i = 0; i < arr[2].size(); i++) {
            if (all.count(arr[2][i]) == 0) {
                s += arr[2][i];
                all.insert(arr[2][i]);
            }
        }
        string tmp;
        for (int i = 0; i < s.size(); i++) {
            tmp += s[i];
            if (tmp.size() == d[2]) {
                all.insert(tmp);
                tmp.clear();
            }
        }
        return;
    }
    if (l == d[4] * 4) {
        for (int i = 0; i < arr[4].size(); i++) {
            if (all.count(arr[4][i]) == 0) {
                all.insert(arr[4][i]);
                s += arr[4][i];
            }
        }
        string tmp;
        for (int i = 0; i < s.size(); i++) {
            tmp += s[i];
            if (tmp.size() == d[4]) {
                all.insert(tmp);
                tmp.clear();
            }
        }
        return;
    }
    if (l == d[8] * 8) {
        for (int i = 0; i < arr[8].size(); i++) {
            if (all.count(arr[8][i]) == 0) {
                s += arr[8][i];
                all.insert(arr[8][i]);
            }
        }
        string tmp;
        for (int i = 0; i < s.size(); i++) {
            tmp += s[i];
            if (tmp.size() == d[8]) {
                all.insert(tmp);
                tmp.clear();
            }
        }
        return;
    }
    if (l == d[16] * 16) {
        for (int i = 0; i < arr[16].size(); i++) {
            if (all.count(arr[16][i]) == 0) {
                s += arr[16][i];
                all.insert(arr[16][i]);
            }
        }
        return;
    }
}

void gen(ll l, string &s) {
    if (l == 1) {
        return;
    }
    if (l == d[2] * 2 || l == d[4] * 4 || l == d[8] * 8 || l == d[16] * 16) {
        pl(l, s);
        return;
    }
    gen(l / 2, s);
    if (l < d[2] * 2) {
        for (int i = 0; i < arr[2].size(); i++) {
            if (l == d[2] * 2 || l == n) return;
            if (all.count(arr[2][i]) == 0) {
                all.insert(arr[2][i]);
                s += arr[2][i];
            }
        }
    }
    if (l > d[2] * 2 && l < d[4] * 4) {
        for (int i = 0; i < arr[4].size(); i++) {
            if (s.size() == d[4] * 4 || s.size() == d[n]) return;
            if (all.count(arr[4][i]) == 0) {
                all.insert(arr[4][i]);
                s += arr[4][i];
            }
        }
    }
    if (l > d[4] * 4 && l < d[8] * 8) {
        for (int i = 0; i < arr[8].size(); i++) {
            if (s.size() == d[8] * 8 || s.size() == d[n]) return;
            if (all.count(arr[8][i]) == 0) {
                all.insert(arr[8][i]);
                s += arr[8][i];
            }
        }
    }
    if (l > d[8] * 8 && l < d[16] * 16) {
        for (int i = 0; i < arr[16].size(); i++) {
            if (s.size() == d[16] * 16 || s.size() == d[n]) return;
            if (all.count(arr[16][i]) == 0) {
                all.insert(arr[16][i]);
                s += arr[16][i];
            }
        }
    }
}

void solve() {
    cin >> n;
    if (n == 1) {
        cout << "01";
        return;
    }
    if (n == 2) {
        cout << "0011";
        return;
    }
    string s;
    arr.resize(17);
    d.resize(30, 1);
    for (int i = 1; i < 30; i++) d[i] = d[i - 1] * 2;
    for (int i = 2; i <= 16; i *= 2) rec(i, s);
    string r;
    gen(d[n], r);
    cout << r;
}

int main(){
    solve();
    return 0;
}
