#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 0;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool cmp(pll a, pll b) {
    return (a.first + a.second < b.first + b.second);
}

void solve() {
    int n;
    cin >> n;
    vector<pll> x(n);
    vector<ll> a(n);
    ll sa = 0, sb = 0;
    vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i].first;
        a[i] = x[i].first;
        sa += a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> x[i].second;
        b[i] = x[i].second;
        sb += b[i];
    }
    sort(all(x), cmp);
    int cnt = 0;
    bool ok = 1;
    ll saved = 0;
    for (int i = 0; i < n; ++i) {
        ll d = min(saved, x[i].first);
        saved -= d;
        x[i].first -= d;
        ll lol = sa - x[i].first;
        if (lol < x[i].second) ++cnt;
        else {
            sa -= x[i].second;
            saved += x[i].second;
        }
    }
//    cerr << cnt << en;
    cout << (cnt >= 2 ? "NO" : "YES") << en;
}

int main() {
    START_TIME = clock();
    fast_in_out();
#ifdef __APPLE__
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << en << TIME * 1000 << " ms." << en;
#endif
    return 0;
}
