/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,tune=native")
*/

#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <string>
#include <utility>
#include <set>
#include <stack>
#include <deque>
#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <climits>
#include <queue>
#include <cstring>
#include <bitset>
#include <iomanip>
#include <chrono>

#ifdef LOCAL
	#define dbg(x) cerr << #x << " : " << x << endl;
#else
	#define dbg(x)
#endif


#define int long long
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define all(x) x.begin(), x.end()
#define sz(a) (int)a.size()
#define siz(a) (int)a.size()
#define fr first
#define se second
#define cinv(v) for (auto& x: v) cin >> x
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, v) for (auto &x : v)

template <typename T1, typename T2> inline bool chkmin(T1 &x, const T2 &y) {if (x > y) {x = y; return 1;} return 0;}
template <typename T1, typename T2> inline bool chkmax(T1 &x, const T2 &y) {if (x < y) {x = y; return 1;} return 0;}

#define mine chkmin
#define maxe chkmax

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef vector<ch> vch;
typedef vector<str> vs;

const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 50;
const long long BIG = (long long)2e18 + 50;
const int MX = 200010;
const double EPS = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

template<typename T> ostream& operator<< (ostream &out, const vector<T> &b) {
	for (auto k : b) out << k << ' ';
	return out;
}

template<typename T> istream& operator>> (istream &in, vector<T> &b) {
	for (auto& k : b) in >> k;
	return in;
}

istream& operator>> (istream& in, pii& b) {
	in >> b.first >> b.second;
	return in;
}

ostream& operator<< (ostream& out, const pii& b) {
	out << "{" << b.first << ", " << b.second << "}";
	return out;
}


int bad[MX];
int good[MX];

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		int sb = 0;
		int sg = 0;
		fi(0, n) {
			cin >> bad[i];
			sb += bad[i];
		}
		fi(0, n) {
			cin >> good[i];
			sg += good[i];
		}
		vi suka;
		fi(0, n) {
			if (good[i] > sb - bad[i]) {
				suka.pb(i);
			}
		}
		auto check = [&](int i) {
			return sb >= sg - good[i];
		};
		int ans = 0;
		if (suka.size() > 1) {
			ans = 0;
		} else if (suka.size() == 1) {
			ans |= check(suka[0]);
		} else {
			fi(0, n)
				ans |= check(i);
		}
		cout << (ans ? "YES\n" : "NO\n");
	}

}
