#include <bits/stdc++.h>

using namespace std;

#define line pair<pair<int, int>, pair<int, int> >

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.first * b.second - a.second * b.first > 0;
}

int cp(pair<int, int> a, pair<int, int> b, pair<int, int> c)
{
    b.first -= a.first;
    b.second -= a.second;
    c.first -= a.first;
    c.second -= a.second;
    return b.first * c.second - b.second * c.first;
}

bool good(pair<int, int> a, pair<int, int> b, pair<int, int> c)
{
    return (cp(b, a, c) > 0);
}

vector<pair<int, int> > v;
set<pair<int, int> > edge;

bool inter(line a, line b)
{
    if (a.second > a.first) swap(a.first, a.second);
    if (b.second > b.first) swap(b.first, b.second);
    if (a.first == b.first && a.second == b.second) return true;
    if (a.first == b.first || a.first == b.second || a.second == b.first || a.second == b.second) return false;
    int c1 = cp(a.first, b.first, b.second);
    int c2 = cp(a.second, b.first, b.second);
    if (c1 < 0 && c2 < 0) return false;
    if (c1 > 0 && c2 > 0) return false;
    return true;

}

bool inter(pair<int, int> a, pair<int, int> b)
{
    return inter({v[a.first], v[a.second]}, {v[b.first], v[b.second]});
}

void del(pair<int, int> d)
{
    vector<pair<int, int> > bad;
    for (auto k : edge)
    {
        if (inter(k, d)) bad.push_back(k);
    }
    for (auto k : bad) edge.erase(k);
}


int main()
{
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.end());
    for (int i = 1; i < n; ++i)
    {
        v[i].first -= v[0].first;
        v[i].second -= v[0].second;
    }
    v[0] = {0, 0};
    sort(++v.begin(), v.end(), cmp);
    vector<int> st;
    st.push_back(0);
    st.push_back(1);
    for (int i = 2; i < v.size(); ++i)
    {
        while (st.size() > 2)
        {
            if (good(v[st[st.size() - 2]], v[st[st.size() - 1]], v[i])) st.pop_back();
            else break;
        }
        st.push_back(i);
    }
    int phase = 0;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            edge.insert({i, j});
    if ((n - st.size()) % 2 == 0)
    {
        cout << 1 << endl;
        phase = 1;
    }
    else
    {
        cout << 2 << endl;
        phase = -1;
    }
    while (true)
    {
        if (phase == -1)
        {
            int x, y;
            cin >> x >> y;
            if (x == 0 && y == 0) return 0;
            --x;
            --y;
            del({x, y});
        }
        else
        {
            cout << (edge.begin() -> first) + 1 << " " << (edge.begin() -> second) + 1 << endl;
            del(*edge.begin());
        }
        phase *= -1;
    }
}
