#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

const int N = 16;

#define int long long

int dp[N];
int fdp[N][N];
int sdp[N][N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    fdp[0][0] = 1;
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            for (int tk = max((int)1, j); i + tk < N; tk++) {
                fdp[i + tk][tk] += fdp[i][j];
            }
        }
    }
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            dp[i] += fdp[i][j];
        }
    }
    sdp[0][0] = 1;
    int n, k;
    cin >> n >> k;
    for (int i = 0; i + 1 < N; i++) {
        for (int j = 0; j < N; j++) {
            for (int tk = 0; j + tk < N; tk++) {
                sdp[i + 1][j + tk] += dp[tk] * sdp[i][j];
            }
        }
    }
    cout << sdp[k][n] << endl;
}
