#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;
typedef long long ll;
struct point
{
    int x,y;
};
int operator*(point a, point b)
{
    return a.x*b.y-a.y*b.x;
}
int n;
vector<point> a;
bool operator==(point a, point b)
{
    return a.x==b.x&&a.y==b.y;
}
int operator%(point a, point b)
{
    return a.x*b.x+a.y*b.y;
}
int sgn(int x)
{
    return (x> 0 ? 1 : (x== 0 ? 0 : -1));
}
point operator-(point a, point b)
{
    return {a.x-b.x,a.y-b.y};
}
bool intersect(point a, point b, point c, point d)
{
    int ok = ( sgn((c-a) * (d-a)) * sgn((c-b) * (d-b)) == - 1);
    swap(a,c);
    swap(b,d);
    ok&= ( sgn((c-a) * (d-a)) * sgn((c-b) * (d-b)) == - 1);
    return ok;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    a.resize(n);
    for(int i= 0; i < n;++i) cin>>a[i].x>>a[i].y;
    vector<vector<bool>> were(n, vector<bool> (n));
    int cnt=0;
    vector<pair<point,point>> e;
        for(int i =0 ;i< n;++i)
        {
            for(int j = i+1;j< n;++j)
            {
                if( were[i][j]) continue;
                bool f= 0;
                for(auto kek : e)
                {
                    if(intersect(kek.first, kek.second, a[i], a[j]))
                    {
                        f=1;
                    }
                }
                if(!f)
                {
                    e.push_back(make_pair(a[i], a[j]));

                }
            }
        }

    if(e.size() % 2)
    {
        e.clear();
        cout<<1<<endl;
        for(int i =0 ; i< n;++i)
        {
            for(int j = i+1;j< n;++j)
            {
                if(were[i][j]) continue;
                bool f = 0;
                for(auto kek : e)
                {
                    if(intersect(kek.first, kek.second, a[i], a[j])) f=1;
                }
                if(!f)
                {
                    cout<<i+1<<' '<< j+1<<endl;
                    e.push_back(make_pair(a[i], a[j]));
                    int x,y;
                    cin>>x>>y;
                    if( x== 0 && y==0)
                    {
                        return 0;
                    }
                    x--;y--;
                    were[x][y] = were[y][x] = 1;
                    if(x>y) swap(x,y);
                    e.push_back(make_pair(a[x], a[y]));
                }
            }
        }
    }
    else
    {
        e.clear();
        cout<<2<<endl;
        int x,y;
        cin>>x>>y;
        if(x==0 && y==0)
        {
            return 0;
        }
        x--;y--;
        if(x>y) swap(x,y);
        were[x][y]=were[y][x]=1;
        e.push_back(make_pair(a[x], a[y]));
        for(int i =0 ; i< n;++i)
        {
            for(int j  = i+1;j< n;++j)
            {
                if(were[i][j]) continue;
                bool f = 0;
                for(auto kek : e)
                {
                    if(intersect(kek.first, kek.second,a[i],a[j])) f=1;
                }
                if(!f)
                {
                    cout<<i+1<<' '<< j+1<<endl;
                    e.push_back(make_pair(a[i], a[j]));
                    int x,y;
                    cin>>x>>y;
                    if(x==0 && y==0)
                    {
                        return 0;
                    }
                    x--;y--;
                    if(x>y) swap(x,y);
                    were[x][y] = were[y][x] =1;
                    e.push_back(make_pair(a[x], a[y]));
                }
            }
        }
    }
    e.clear();

}
