#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <deque>
#include <iomanip>
#include <queue>

using namespace std;

#define int long long

int ans = 0;

int N, K;

void gen(int n, vector<int> &x) {
    if (n == 0) {
        vector<vector<int>> dp(x.size(), vector<int> (K, 0));
        for(int i = 0; i < K; ++i) {
            dp[0][i] = 1;
        }
        for(int i = 1; i < x.size(); ++i) {
            for(int j = 0; j < K; ++j) {
                if (x[i] == x[i - 1]) {
                    for(int l = 0; l <= j; ++l) {
                        dp[i][j] += dp[i - 1][l];
                    }
                }
                else {
                    for(int l = 0; l < K; ++l) {
                        dp[i][j] += dp[i - 1][l];
                    }
                }
            }
        }
        int curr = 0;
        for(int i : dp.back()) {
            ans += i;
            curr += i;
        }
        return;
    }
    int start = 1;
    if (x.size()) {
        start = x.back();
    }
    for(int i = start; i <= n; ++i) {
        x.push_back(i);
        gen(n - i, x);
        x.pop_back();
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    N = n, K = k;
    vector<int> x;
    gen(n, x);
    cout << ans;
}
