#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <sstream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <fstream>
#include <vector>
#include <string>
#include <random>
#include <bitset>
#include <regex>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <stack>
#include <set>
#include <map>

#define all(q) q.begin(), q.end()
#define ever (;;)
#define Please return
#define AC 0

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;
using ll = long long;
using ld = long double;
constexpr int MAXN = 1000;
constexpr int MAXSOF = (int)5e5;
vector<int> g[MAXSOF] = {};
vector<int> conn[MAXN][MAXN] = {};
int used[MAXSOF] = {};
bool c[MAXSOF] = {};
int t = 1;

pair<int, bool> dfs1(int v, int p = -1)
{
	used[v] = t;
	int sz = 1;
	bool flag = false;
	for (int to : g[v])
	{
		if (used[to])
		{
			if (to != p)
				flag = true;
			continue;
		}

		pair<int, bool> buf = dfs1(to, v);
		sz += buf.first;
		if (buf.second)
			flag = true;
	}

	return make_pair(sz, flag);
}

void dfs2(int v, bool col)
{
	c[v] = col;
	used[v] = t;
	if (c[v])
	{
		for (int to : g[v])
		{
			if (c[to])
			{
				c[v] = false;
				break;
			}
		}
	}

	for (int to : g[v])
		if (used[to] != t)
			dfs2(to, !col);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<string> field(n);
	for (int i = 0; i < n; ++i)
		cin >> field[i];
	
	vector<pair<pair<int, int>, pair<int, int>>> sofas, ext;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			if (field[i][j] == '.')
				continue;
			if (i + 1 < n && field[i + 1][j] == field[i][j])
			{
				sofas.emplace_back(make_pair(i, j), make_pair(i + 1, j));
				if (islower(field[i][j]))
					ext.emplace_back(make_pair(i, j - 1), make_pair(i + 1, j - 1));
				else
					ext.emplace_back(make_pair(i, j + 1), make_pair(i + 1, j + 1));
			}
			if (j + 1 < m && field[i][j] == field[i][j + 1])
			{
				sofas.emplace_back(make_pair(i, j), make_pair(i, j + 1));
				if (islower(field[i][j]))
					ext.emplace_back(make_pair(i - 1, j), make_pair(i - 1, j + 1));
				else
					ext.emplace_back(make_pair(i + 1, j), make_pair(i + 1, j + 1));
			}
		}
	}

	vector<bool> bad(sofas.size(), false);
	for (int i = 0; i < (int)sofas.size(); ++i)
	{
		if (ext[i].first.first < 0 || ext[i].first.first >= n || ext[i].first.second < 0 || ext[i].first.second >= m ||
			ext[i].second.first < 0 || ext[i].second.first >= n || ext[i].second.second < 0 || ext[i].second.second >= m)
		{
			bad[i] = true;
			continue;
		}
		
		if (field[ext[i].first.first][ext[i].first.second] != '.' || field[ext[i].second.first][ext[i].second.second] != '.')
		{
			bad[i] = true;
			continue;
		}

		conn[ext[i].first.first][ext[i].first.second].push_back(i);
		conn[ext[i].second.first][ext[i].second.second].push_back(i);
	}

	for (int i = 0; i < (int)sofas.size(); ++i)
	{
		if (bad[i])
		{
			g[i].push_back(i);
			continue;
		}

		set<int> hz;
		hz.insert(all(conn[ext[i].first.first][ext[i].first.second]));
		hz.insert(all(conn[ext[i].second.first][ext[i].second.second]));
		hz.erase(i);
		for (int x : hz)
			g[i].push_back(x);
	}

	int ans = 0;
	for (int v = 0; v < (int)sofas.size(); ++v)
	{
		if (used[v] == t)
			continue;
		pair<int, bool> buf = dfs1(v);
		if (buf.second)
			ans += buf.first >> 1;
		else
			ans += (buf.first + 1) >> 1;
	}

	++t;
	for (int v = 0; v < (int)sofas.size(); ++v)
		if (used[v] != t && g[v].size() == 1)
			dfs2(v, true);
	for (int v = 0; v < (int)sofas.size(); ++v)
	{
		if (used[v] == t)
			continue;
		dfs2(v, true);
	}

	vector<string> res;
	res.assign(n, string(m, '.'));
	for (int i = 0; i < (int)sofas.size(); ++i)
	{
		pair<int, int> ul = sofas[i].first;
		if (c[i])
			ul = min(ul, ext[i].first);
		int num = (ul.first + ul.second * 3) % 10;

		res[sofas[i].first.first][sofas[i].first.second] = '0' + num;
		res[sofas[i].second.first][sofas[i].second.second] = '0' + num;
		if (c[i])
		{
			res[ext[i].first.first][ext[i].first.second] = '0' + num;
			res[ext[i].second.first][ext[i].second.second] = '0' + num;
		}
	}

	cout << ans << '\n';
	for (int i = 0; i < n; ++i)
		cout << res[i] << '\n';

	Please AC;
}