#include <iostream>
#include <vector>
#include "math.h"



using namespace std;
typedef long long ll;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define minim(x) min_element((x).begin(), (x).end())
#define maxim(x) max_element((x).begin(), (x).end())
#define fori(i, n) for (long long (i) = 0; (i) < (n); ++(i))

template <class T>
istream& operator >>(istream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in >> i;
    }
    return in;
}

template <class T>
ostream& operator <<(ostream &in, vector<T> &arr)
{
    for (T &i : arr)
    {
        in << i << " ";
    }
    return in;
}


int main() {
    int t;
    cin >> t;
    for(int q = 0; q < t; ++q) {
        int n;
        cin >> n;
        vector<ll> a(n);
        vector<ll> b(n);
        cin >> a >> b;
        ll sa = 0, sb = 0;
        for(int i = 0; i < n; ++i){
            sa += a[i];
            sb += b[i];
        }
        int k = -1;
        bool tr = false;
        for(int i = 0; i < n; ++i) {
            if(sa - a[i] < b[i]) {
                if(k == -1){
                    k = i;
                }else{
                    tr = true;
                    break;
                }
            }
        }
        if(tr) {
            cout << "NO\n";
            continue;
        }
        if(k != -1) {
            if(sb - b[k] <= sa){
                cout << "YES\n";
            }else{
                cout << "NO\n";
            }
            continue;
        }
        tr = false;
        for(int i = 0; i < n; ++i) {
            if(sb - b[i] <= sa) {
                tr = true;
                break;
            }
        }
        if(tr) {
            cout << "YES\n";
        }else{
            cout << "NO\n";
        }
    }
    return 0;
}
