#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

string convert(ll n, ll c)
{
    string w = "";
    while (n > 0)
    {
        w.push_back((char)('0' + (n % 2)));
        n /= 2;
    }
    while (w.size() < c) w.push_back('0');
    reverse(w.begin(), w.end());
    return w;
}

int main()
{
    ll n;
    cin >> n;
    if (n == 1)
    {
        cout << "01";
        return 0;
    }
    ll block_size = 1LL << (n / 2);
    ll b = 0, e = (1LL << block_size) - 1;
    ll k = 0;
    for (ll i = 0; i < (1LL << n); i += block_size)
    {
        if (k % 2 == 0)
        {
            cout << convert(b, block_size);
            b++;
        }
        else
        {
            cout << convert(e, block_size);
            e--;
        }
        k++;
    }
    return 0;
}
