#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, w;

int calc(const vector< tuple<int, int, int> >& aa) {
	int curw = 0;
	int curc = 0;
	for(auto [ww, cc, ii]: aa) {
		if(curw + ww <= w) {
			curw += ww;
			curc += cc;
		}
	}
	return curc;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	for(int q = 0; q < t; q++) {
		cin >> n >> w;
		w = w + w / 2;

		vector< tuple<int, int, int> > aa(n);
		for(int i = 0; i < n; i++) {
			cin >> get<0>(aa[i]) >> get<1>(aa[i]);
			get<2>(aa[i]) = i;
		}

		sort(aa.begin(), aa.end(), [](auto a, auto b) {
			return get<0>(b) * get<1>(a) > get<0>(a) * get<1>(b);
		});

		vector< tuple<double, int, int, int> > bb;
		for(auto [ww, cc, ii]: aa) {
			bb.emplace_back((double)ww / cc, ww, cc, ii);
			bb.emplace_back((double)ww / cc * 1.5, ww, cc, ii);
		}
		sort(bb.begin(), bb.end());
		vector<bool> take1(n);
		int curw = 0;
		int curc = 0;
		for(auto [_, ww, cc, ii]: bb) {
			if(!take1[ii] && curw + ww <= w) {
				take1[ii] = true;
				curw += ww;
				curc += cc;
			}
		}

		int oldans = calc(aa);

		double temp = 1;
		for(int i = 0; i < 150; i++) {
			auto aanew = aa;
			for(int j = 0; j < (int)(temp * (n + 1)); j++) {
				swap(aanew[rand() % n], aanew[rand() % n]);
			}
			int newans = calc(aanew);
			if(newans > oldans || rand() < RAND_MAX * exp(-(oldans - newans) / temp)) {
				aa = aanew;
				oldans = newans;
			}
			temp *= 0.99;
		}

		vector<int> ans;
		if(curc > oldans) {
			for(int i = 0; i < n; i++) {
				if(take1[i]) {
					ans.push_back(i);
				}
			}
		} else {
			for(auto [ww, cc, ii]: aa) {
				if(w >= ww) {
					w -= ww;
					ans.push_back(ii);
				}
			}
		}

		cout << ans.size() << "\n";

		for(int x: ans) {
			cout << x + 1 << " ";
		}
		cout << "\n";
	}

	return 0;
}