
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <iomanip>
#include <map>
#include <cmath>
#include <bitset>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <random>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cassert>
using namespace std;
typedef long long int ll;
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    int t;

    cin >> t;
    while (t --> 0) {
        int n;

        cin >> n;
        vector<int> a(n), b(n);
        ll asum = 0;
        for (int &i : a) {
            cin >> i;
            asum += i;
        }
        ll bsum = 0;
        for (int &i : b) {
            cin >> i;
            bsum += i;
        }

        bool impossible = false;
        for (int i = 0; !impossible && i < n; ++i) {
            ll err = 0;
            for (int j = 0; j < n; ++j) {
                if (i == j) {
                    err += max(0ll, -bsum + a[i] + b[i]);
                } else {
                    err += max(0ll, -bsum + a[j] + b[i] + b[j]);
                }
            }
            impossible |= (asum - err) >= (bsum - b[i]);
        }

        cout << (impossible ? "YES\n" : "NO\n");
    }
    return 0;
}