
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <iomanip>
#include <map>
#include <cmath>
#include <bitset>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <random>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cassert>
using namespace std;
//typedef long long int ll;
#define int __int128
vector<int> p(20);
int get(int L, int R, vector<int> &pr){
    if (L > R) return 0;
    if (L == 0) return pr[R];
    return pr[R] - pr[L - 1] * p[R - L + 1];
}
void solve(){
    string l,r;
    cin >> l >> r;
    int numl = 0,numr = 0;
    while(l.size() < r.size()){
        l = '0' + l;
    }
    vector<int> L,R;
    for (int i = 0; i < l.size(); ++i){
        L.push_back(l[i] - '0');
        R.push_back(r[i] - '0');
    }
    //reverse(L.begin(),L.end());
    //reverse(R.begin(),R.end());
    for (int i = 0; i < L.size(); ++i){
        numl = numl * 10 + L[i];
        numr = numr * 10 + R[i];
    }
    vector<int> prR(R.size()), prL(L.size());
    p[0] = 1;
    for (int i = 1; i < 20; ++i) p[i] = p[i-1] * 10;
    prR[0] = R[0];
    prL[0] = L[0];
    for (int i = 1; i < L.size(); ++i){
        prR[i] = prR[i-1] * 10 + R[i];
        prL[i] = prL[i-1] * 10 + L[i];
    }
    long long anslen = 1, ans = numr - numl + 1;
    for (int len = 2; len <= 18; ++len){
        int curans = 0;
        for (int num = 0; num <= 9; ++num){
            int s = num;
            for (int i = 1; i < len; ++i){
                s = 10 * s + num;
            }
            for (int L = num == 0 ? 1 : 0; L + len - 1 < prL.size(); ++L){
                int R = L + len - 1;
                int newl = numl - (get(L,R, prL) - s) * p[prL.size() - R - 1];
                if (newl < numl) newl += p[prL.size() - L] - get(R + 1, prL.size() - 1, prL);
                if (newl > numl) newl -= get(R + 1, prL.size() - 1, prL);
                int newr = numr - (get(L,R, prR) - s) * p[prR.size() - R - 1];
                if (newr < numr) newr += p[prL.size() - R - 1] - 1 - get(R + 1, prR.size() - 1, prR);
                if (newr > numr) {
                    newr += p[prL.size() - R - 1] - 1;
                    newr -= get(R + 1, prR.size() - 1, prR);
                    newr -= p[prR.size() - L];
                }
                int sumL = 0, sumR = 0;
            if (newl <= newr && newl >= numl && newl <= numr && newr >= numl && newr <= numr) {
                for (int i = prL.size() - 1; i >= 0; --i) {
                    int ln = newl % 10;
                    int rn = newr % 10;
                    newl /= 10;
                    newr /= 10;
                    if (i >= L && i <= R) continue;
                    sumL *= 10;
                    sumR *= 10;
                    sumL += ln;
                    sumR += rn;
                }
                curans += sumR - sumL + 1;
            }
            }
        }
        if (curans > 0){
            anslen = len;
            ans = curans;
        }
    }
    cout << anslen << ' ' << min((long long)numr - (long long)numl + 1,ans) << '\n';
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    long long t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}