#define _USE_MATH_DEFINES

#include <iostream>
#include <random>
#include <iomanip>
#include <functional>
#include <vector>
#include <set>
#include <map>
using namespace std;

//#ifndef ONLINE_JUDGE
//#define DEBUG
//#endif

#ifndef DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#endif

std::random_device rn;
std::mt19937 rng(rn());

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
int time_DEBUG;
#endif

void geom_out() {
    std::cout.setf(std::ios::fixed);
#ifdef DEBUG
    std::cout << std::setprecision(8);
#else
    std::cout << std::setprecision(35);
#endif
}

void fast_in_out() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void begin_ex() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    time_DEBUG = clock();
#endif
    fast_in_out();
    geom_out();
}

void end_ex() {
#ifdef DEBUG
    std::cerr << '\n' << static_cast<double>(clock() - time_DEBUG) / (CLOCKS_PER_SEC * 1.0) << " sec\n";
#endif
}

void solve() {
    int t1, v1, t2, v2;
    cin >> t1 >> v1 >> t2 >> v2;
    if (t2 < 0 && v2 >= 10) {
        cout << "A storm warning for tomorrow! Be careful and stay home if possible!\n";
    } else if (t2 < t1) {
        cout << "MCHS warns! Low temperature is expected tomorrow.\n";
    } else if (v2 > v1) {
        cout << "MCHS warns! Strong wind is expected tomorrow.\n";
    } else {
        cout << "No message\n";
    }
}

signed main() {
    begin_ex();

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    end_ex();
    return 0;
}