﻿/*#define _USE_MATH_DEFINES
#pragma GCC optimize("Ofast")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-ffast-math")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")*/

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdlib>
#include <string>
#include <deque>
#include <functional>
#include <set>
#include <map>
#include <random>
#include <cstdlib>
#include <memory>   
#include <assert.h>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <time.h>
#include <stack>
#include <queue>

using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;


#define si(n) scanf("%d", &n)
#define dout(n) printf("%d\n", n)
#define forn(i, n) for (ll i = 0; i < (n); ++i)
#define pi 3.141592653589793238462643383279
#define vll vector <ll>
#define ve vector
#define de deque
#define sll set <ll>
#define msll multiset <ll>
#define dll deque <ll>
#define pll pair <ll, ll>
#define print(h) for (auto ijkl : h) cout << ijkl << " "; cout << "\n"
#define prints(h, s) for (ll ijkl = 0; ijkl < h.size(); ++ijkl) cout << h[ijkl] << s; cout << "\n"
#define printvpll(h) for (auto ijkl : h) cerr << ijkl.ft << ":" << ijkl.sd << " "; cerr << "\n";
#define scan(h, n) for (int ijkl = 0; ijkl < n; ++ijkl) cin >> h[ijkl]
#define INF 1e18
#define pow2(n) (n)    *    (n)
#define pow3(n) (n) * (n) * (n)
#define all(x) (x).begin(), (x).end()
#define MOD ll(1e9 + 7)
#define MOD2 ll(998244353)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define elif else if
#define ft first
#define sd second
#define look1(x)          cerr << #x << ": " << x << endl;
#define look2(x, y)       cerr << #x << ": " << x << " | " << #y << ": " << y << endl;
#define look3(x, y, z)    cerr << #x << ": " << x << " | " << #y << ": " << y << " | " << #z << ": " << z << endl;
#define look4(a, b, c, d) cerr << #a << ":" << a << " | " << #b << ":" << b << " | " << #c << ":" << c << " | " << #d << ":" << d << "\n";

/*ll f() {
    int a = 0;
    char c = ' ';
    bool flag = false;
    while (!isdigit(c))
    {
        c = _getchar_nolock();
        if (c == '-')
            flag = true;
    }
    while (isdigit(c)) {
        a = a * 10 + (c - '0');
        c = _getchar_nolock();
    }
    if (flag)
        return -a;
    return a;
}*/


ll maxn(ve <ll>& h) {
    ll ans = -INF;
    for (int ijkl = 0; ijkl < h.size(); ++ijkl) {
        ans = max(ans, (ll)h[ijkl]);
    }
return ans;
}

ll minn(ve <ll>& h) {
    ll ans = INF;
    for (int ijkl = 0; ijkl < h.size(); ++ijkl) {
        ans = min(ans, (ll)h[ijkl]);
    }
    return ans;
}

ll sumn(vll& h) {
    ll ans = 0;
    for (int ijkl = 0; ijkl < h.size(); ++ijkl) {
        ans += h[ijkl];
    }
    return ans;
}

ll pown(ll n, ll cnt, ll mod) {
    //look1(cnt);
    if (cnt == 0) {
        return 1;
    }
    if (cnt == 1) {
        return n;
    }
    if (cnt % 2 == 0) {
        ll a = pown(n, cnt / 2, mod);
        return (a * a % mod);
    }
    else {
        ll a = pown(n, (cnt - 1) / 2, mod);
        return (a * a) % mod * n % mod;
    }
}

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
    return a * b / gcd(a, b);
}

bool check(ll n, ll m, ll x, ll y) {
    return (x < n && x >= 0 && y < m && y >= 0);
}

/*ld dist(ld x1, ld y1, ld x2, ld y2) {
    return sqrt(pow2(x1 - x2) + pow2(y1 - y2));
}*/

struct Point {
    ld x, y, dist;
    Point() : x(0), y(0), dist(0) {}
    Point(ld _x, ld _y) : x(_x), y(_y), dist(sqrt(pow2(_x) + pow2(_y))) {}
};

int get_pol(ld x, ld y) {
    if (x >= 0 && y > 0) {
        return 0;
    }
    elif(x < 0 && y >= 0) {
        return 1;
    }
    elif(x <= 0 && y < 0) {
        return 2;
    }
    elif(x > 0 && y <= 0) {
        return 3;
    }
    return 4;
}

string alph = "0123456789abcdefghijklmnopqrstuvwxyz";

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);    
    ld k;
    cin >> k;
    ld ans = 25 + k / 100;
    cout << fixed << setprecision(10);
    cout << min((ld)2000, max((ld)100, ans));
    return 0;
}