// @iamnifer
#include <iostream>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define ull unsigned long long
#define uint usigned int
#define elif else if
#define pb push_back
#define add insert
#define fastio cout.tie(nullptr); cin.tie(nullptr); ios_base::sync_with_stdio(false)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define len(x) (int)((x).size())
#define gcd __gcd
#define lcm(a, b) (a)/gcd((a), (b))*(b)
#define precision(x) cout << fixed << setprecision((x))

using namespace std;
using namespace __gnu_pbds;

typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<ld, ld> pld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> ordered_multiset;
typedef vector<vector<int>> graph;

template<typename A, typename B>
inline void umin(A &a, B b) {
    if (a > b) a = b;
}

template<typename A, typename B>
inline void umax(A &a, B b) {
    if (a < b) a = b;
}

template<typename T>
T binpow(T b, T e, T m) {
    T r = 1;
    while (e > 0) {
        if (e & 1) r = r * b % m;
        b = b * b % m;
        e >>= 1;
    }
    return r;
}

string to_string(string &s) {
    return "\"" + s + "\"";
}

template<typename A, typename B>
string to_string(pair<A, B> v) {
    return "{" + to_string(v.first) + " " + to_string(v.second) + "}";
}

template<typename T>
string to_string(set<T> v) {
    string r = "{", e;
    for (auto i : v) r += e + to_string(i), e = ", ";
    return r + "}";
}

template<typename T>
string to_string(vector<T> v) {
    string r = "{", e;
    for (auto i : v) r += e + to_string(i), e = ", ";
    return r + "}";
}

void debug() {
    cerr << endl;
}

template<typename Head, typename...Tail>
void debug(Head H, Tail...T) {
    cerr << " " << to_string(H);
    debug(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug(__VA_ARGS__)
#else
#define debug(...) 0
#endif

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma,sse4")
// #pragma comment(linker,"/STACK:128777216")

// #pragma GCC optimize("O3")

const ld pi = 3.14159265358979323846264338327950288419716939937510;
const ld eps = 1e-8;
const int inf = 1e9;
const ll MOD = 1e9 + 7;  // 998244353
const int maxN = 2e5 + 9;

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    fastio;
    int n, m, s;
    cin >> n >> m >> s;
    vector<int> q;
    for(int i = 0; i < m; ++i) {
        int x; cin >> x;
        q.pb(x);
    }
    if(m > n) {
        cout << 0;
        return 0;
    }
    sort(all(q));
    int ans = 0;
    reverse(all(q)); // num needs to be >= m - s
    ordered_set z;
    int lessthanr, RRR, mL, rL;
    int pmL = n + 1;
    for(auto &L: q) {
        z.insert(L);
        int R = L + m - 1;
        lessthanr = z.order_of_key(R + 1);
        if(lessthanr >= m - s) {
            RRR = *z.find_by_order(m - s - 1);
            mL = max(1, RRR - m + 1); umin(mL, n - m + 1);
            rL = min(L, n - m + 1); umin(rL, pmL - 1); umin(rL, n - m + 1);
            pmL = mL;
            ans += max(rL - mL + 1, 0);
        }
    }
    cout << ans << '\n';
}
/*
10 5 2
1 3 5 6 7
 */