#include <iostream>
#include <unordered_set>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

int main() {
	
	int t;
	cin >> t;
	
	for (int test = 0; test < t; test++) {
		int n;
		cin >> n;
		int max_id = 0;
		vector <int> nw(n);
		vector <int> w(n);
		for (int i = 0; i < n; i++)
		{
			cin >> nw[i];
		}
		for (int i = 0; i < n; i++) {
			cin >> w[i];
		}
		for (int i = 0; i < n; i++)
		{
			if (nw[i] == nw[max_id] && w[i] > nw[max_id])
				max_id = i;
			if (nw[i] > max_id)
				max_id = i;
		}
		queue <int> q;
		for (int i = 0; i < n; i++)
			if (i != max_id)
				q.push(i);

		for (int i = 0; i < n; i++)
		{
			if (q.empty())
				break;
			bool same = 0;
			while (!q.empty() && nw[i])
			{
				if (q.front() == i) {
					same = true;
					q.pop();
				}
				else
				{
					int a = q.front();
					int m = min(w[a], nw[i]);
					w[a] -= m;
					nw[i] -= m;
					if (!w[a])
						q.pop();
				}
			}
			if (same)
				q.push(i);
		}
		bool f = true;
		for (int i = 0; i < n; i++)
			if (i != max_id && w[i] != 0)
				f = false;

		if (f)
			cout << "YES\n";
		else
			cout << "NO\n";
	}

	//system("pause");
	return 0;
}
