#include <iostream>
#include <unordered_set>
#include <vector>

int main() {
	int n, m, s;
	std::cin >> n >> m >> s;
	std::vector<int> ms;
	ms.resize(m, 0);
	for (int i = 0; i < m; ++i) {
		std::cin >> ms[i];
	}

	std::unordered_set<int> mss(ms.begin(), ms.end());

	int start = 1, end = start + m - 1, count = 0;
	for (int i = start; i <= end; ++i) {
		if (mss.count(i) > 0) {
			count += 1;
		}
	}

	int result = 0;
	while (end <= n) {
		if ((m - count) <= s) {
			result += 1;
		}

		if (mss.count(start) > 0) {
			count -= 1;
		}
		start += 1;
		end += 1;
		if (mss.count(end) > 0) {
			count += 1;
		}
	}

	std::cout << result;

	return 0;
}
