﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <map>
#include <set>
using namespace std;

//for coding
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rd(x) for(auto &i : x) cin >> i;
#define rep(i, l, r) for(int i = (l); i < (r); i++)

//for debug
#define ct(x) for(auto i : x) cout << i << ' ';

vector <long long> f;

void build(int n) {
    f.resize(n + 1, 1);
    for (int i = 2; i <= n; i++) {
        f[i] = (f[i - 1] * i);
    }
}

ll k;

ll rec(int n, vector <int> vec) {
    if (!n) {
        ll ret = 1;
        map <int, ll> mp;
        for (int i : vec)
            mp[i]++;
        for (auto i : mp) {
            ll sum = 0;
            for (int j = 1; j <= min(i.second, k); j++) {
                sum += f[k] / f[j] / f[k - j] * f[i.second - 1] / f[j - 1] / f[i.second - j];
            }
            ret *= sum;
        }
        return ret;
    }
    ll res = 0;
    for (int i = 1; i <= n; i++) {
        if (!vec.size() || i >= vec[vec.size() - 1]) {
            vec.push_back(i);
            res += rec(n - i, vec);
            vec.pop_back();
        }
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> k;
    build(15);
    cout << rec(n, {});
}