#include <bits/stdc++.h>
#define f first
#define s second
#define x first
#define y second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()

//#pragma GCC optimize("O3")

#ifdef LOCAL
#else
    #define err if(0) cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rnd;

const ld eps = 0.5;

struct kok {
    int w, c, i;

    kok (int w = 0, int c = 0, int i = 0) {
        this->w = w;
        this->c = c;
        this->i = i;
    }
};

bool operator <(kok a, kok b) {
    return (ll)a.c * b.w < (ll)a.w * b.c;
}

vector<kok> get_solution(vector<kok> a, ll maxw) {
    int n = a.size();
    int r = -1;
    int lans = 0, rans = -1;
    ll ma = 0;
    ll cur = 0;
    ll w = 0;
    for (int l = 0; l < n; l++) {
        if (l > 0) {
            w -= a[l - 1].w;
            cur -= a[l - 1].c;
        }
        while (r + 1 < n && w + a[r + 1].w <= maxw){
            r++;
            w += a[r].w;
            cur += a[r].c;
        }
        if (cur > ma) {
            lans = l;
            rans = r;
            ma = cur;
        }
    }
    vector<kok> ans;
    for (int i = lans; i <= rans; i++) ans.push_back(a[i]);
    return ans;
}

void solve() {
    int n;
    ll maxw;
    cin >> n >> maxw;
    maxw *= 3;
    maxw /= 2;
    vector<kok> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].w >> a[i].c;
        a[i].i = i;
    }
    sort(a.begin(), a.end());
    vector<kok> ans = get_solution(a, maxw);
    ll ansc = 0;
    for (auto x : ans) ansc += x.c;
    vector<kok> b = a;
    for(int c = 0; c < 100; c++) {
        a = b;
        for (int l = 0; l < n; l += 3) {
            shuffle(a.begin() + l, a.begin() + min(l + 3, (int)a.size()), rnd);
        }
        vector<kok> nans = get_solution(a, maxw);
        ll nc = 0;
        for (auto x : nans) nc += x.c;
        if (nc > ansc) {
            ansc = nc;
            ans = nans;
        }
    }
    cout << ans.size() << '\n';
    for (auto x : ans) cout << x.i + 1<< ' ';
    cout << '\n';
}

signed main() {

#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cout.tie(0);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}


