#include <bits/stdc++.h>
#define pb push_back
#define sz(a) (int)a.size()
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 1005;

int n, m;
char a[N][N];
char a1[N][N];
int used[N * N];
vector<int> comp[2][N * N];
int color[N * N];
int match[N * N];
vector<int> g[N * N], G[N * N];

void dfs1(int v, int c) {
    used[v] = c;
    comp[color[v]][c].pb(v);
    for (int u : g[v]) {
        if (!used[u]) {
            color[u] = color[v] ^ 1;
            dfs1(u, c);
        }
    }
}

bool dfs_find(int v, int c) {
    used[v] = c;
    for (int u : g[v]) {
        if (!match[u]) {
            match[v] = u;
            match[u] = v;
            return 1;
        }
    }
    for (int u : g[v]) {
        if (used[match[u]] != c && dfs_find(match[u], c)) {
            match[v] = u;
            match[u] = v;
            return 1;
        }
    }
    return 0;
}

void dfs2(int v, int c) {
    used[v] = c;
    for (int u : G[v]) {
        if (used[u] != c) {
            dfs2(u, c);
        }
    }
}

int b[N][N];
bool go[N * N];
char answ[N][N];

#define mp make_pair

void do_color(vector<pair<int, int>> v) {
    vector<bool> aoao(10);
    for (auto &p : v) {
        for (int dx : {-1, 0, 1}) {
            for (int dy : {-1, 0, 1}) {
                if (abs(dx - dy) == 1) {
                    if ('0' <= answ[p.X + dx][p.Y + dy] && answ[p.X + dx][p.Y + dy] <= '9') {
                        aoao[answ[p.X + dx][p.Y + dy] - '0'] = true;
                    }
                }
            }
        }
    }
    for (int i = 0; i <= 9; ++i) {
        if (!aoao[i]) {
            for (auto &p : v) {
                answ[p.X][p.Y] = char('0' + i);
            }
            return;
        }
    }
}

vector<int> gg[N][N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            a1[i][j] = s[j - 1];
            a[i][j] = s[j - 1];
        }
    }
    int ptr = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a[i][j] == '.') {
                continue;
            }
            if (a[i][j] == a[i + 1][j]) {
                if ('a' <= a[i][j] && a[i][j] <= 'z') {
                    if (j == 1) {
                        a[i][j] = '.';
                        a[i + 1][j] = '.';
                    } else if (a[i][j - 1] != '.' || a[i + 1][j - 1] != '.') {
                        a[i][j] = '.';
                        a[i + 1][j] = '.';
                    } else {
                        b[i][j] = ptr;
                        b[i + 1][j] = ptr;
                        gg[i][j - 1].pb(ptr);
                        gg[i + 1][j - 1].pb(ptr);
                        ++ptr;
                    }
                } else {
                    if (j == m) {
                        a[i][j] = '.';
                        a[i + 1][j] = '.';
                    } else if (a[i][j + 1] != '.' || a[i + 1][j + 1] != '.') {
                        a[i][j] = '.';
                        a[i + 1][j] = '.';
                    } else {
                        b[i][j] = ptr;
                        b[i + 1][j] = ptr;
                        gg[i][j + 1].pb(ptr);
                        gg[i + 1][j + 1].pb(ptr);
                        ++ptr;
                    }
                }
            } else if (a[i][j] == a[i][j + 1]) {
                if ('a' <= a[i][j] && a[i][j] <= 'z') {
                    if (i == 1) {
                        a[i][j] = '.';
                        a[i][j + 1] = '.';
                    } else if (a[i - 1][j] != '.' || a[i - 1][j + 1] != '.') {
                        a[i][j] = '.';
                        a[i][j + 1] = '.';
                    } else {
                        b[i][j] = ptr;
                        b[i][j + 1] = ptr;
                        gg[i - 1][j].pb(ptr);
                        gg[i - 1][j + 1].pb(ptr);
                        ++ptr;
                    }
                } else {
                    if (i == n) {
                        a[i][j] = '.';
                        a[i][j + 1] = '.';
                    } else if (a[i + 1][j] != '.' || a[i + 1][j + 1] != '.') {
                        a[i][j] = '.';
                        a[i][j + 1] = '.';
                    } else {
                        b[i][j] = ptr;
                        b[i][j + 1] = ptr;
                        gg[i + 1][j].pb(ptr);
                        gg[i + 1][j + 1].pb(ptr);
                        ++ptr;
                    }
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            answ[i][j] = '.';
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a[i][j] == '.') {
                continue;
            }
            if (a[i][j] == a[i + 1][j]) {
                if ('a' <= a[i][j] && a[i][j] <= 'z') {
                    int v = b[i][j];
                    for (int u : gg[i][j - 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                    for (int u : gg[i + 1][j - 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                } else {
                    int v = b[i][j];
                    for (int u : gg[i][j + 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                    for (int u : gg[i + 1][j + 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                }
            } else if (a[i][j] == a[i][j + 1]) {
                if ('a' <= a[i][j] && a[i][j] <= 'z') {
                    int v = b[i][j];
                    for (int u : gg[i - 1][j]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                    for (int u : gg[i - 1][j + 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                } else {
                    int v = b[i][j];
                    for (int u : gg[i + 1][j]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                    for (int u : gg[i + 1][j + 1]) {
                        if (v != u) {
                            g[v].pb(u);
                            g[u].pb(v);
                        }
                    }
                }
            }
        }
    }
    int k = ptr - 1, c = 0;
    for (int i = 1; i <= k; ++i) {
        if (!used[i]) {
            ++c;
            dfs1(i, c);
        }
    }
    fill(used + 1, used + k + 1, 0);
    int ans = 0;
    for (int i = 1; i <= c; ++i) {
        for (int v : comp[0][i]) {
            for (int u : g[v]) {
                if (!match[v] && !match[u]) {
                    match[v] = u;
                    match[u] = v;
                }
            }
        }
        bool found = true;
        int vers = 1;
        while (found) {
            found = false;
            vers++;
            for (int v : comp[0][i]) {
                if (!match[v] && used[v] != vers && dfs_find(v, vers)) {
                    found = true;
                }
            }
        }
        for (int v : comp[0][i]) {
            for (int u : g[v]) {
                if (match[v] == u) {
                    G[v].pb(u);
                } else {
                    G[u].pb(v);
                }
            }
        }
        ++vers;
        for (int v : comp[0][i]) {
            if (match[v] && used[v] != vers) {
                dfs2(v, vers);
            }
        }
        int curr = 0;
        for (int v : comp[0][i]) {
            if (used[v] != vers) {
                curr++;
            }
        }
        for (int v : comp[1][i]) {
            if (used[v] == vers) {
                curr++;
            }
        }
        int mx = max(sz(comp[0][i]), sz(comp[1][i]));
        mx = max(mx, curr);
        if (mx == curr) {
            for (int v : comp[0][i]) {
                if (used[v] != vers) {
                    go[v] = 1;
                    ans++;
                }
            }
            for (int v : comp[1][i]) {
                if (used[v] == vers) {
                    go[v] = 1;
                    ans++;
                }
            }
        } else if (mx == sz(comp[0][i])) {
            for (int v : comp[0][i]) {
                go[v] = 1;
                ans++;
            }
        } else {
            for (int v : comp[1][i]) {
                go[v] = 1;
                ans++;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a1[i][j] == '.') {
                continue;
            }
            if (a1[i][j] == a1[i + 1][j]) {
                if ('a' <= a1[i][j] && a1[i][j] <= 'z') {
                    if (b[i][j] && go[b[i][j]]) {
                        do_color({mp(i, j), mp(i + 1, j), mp(i, j - 1), mp(i + 1, j - 1)});
                    } else {
                        do_color({mp(i, j), mp(i + 1, j)});
                    }
                } else {
                    if (b[i][j] && go[b[i][j]]) {
                        do_color({mp(i, j), mp(i + 1, j), mp(i, j + 1), mp(i + 1, j + 1)});
                    } else {
                        do_color({mp(i, j), mp(i + 1, j)});
                    }
                }
            } else if (a1[i][j] == a1[i][j + 1]) {
                if ('a' <= a1[i][j] && a1[i][j] <= 'z') {
                    if (b[i][j] && go[b[i][j]]) {
                        do_color({mp(i, j), mp(i, j + 1), mp(i - 1, j), mp(i - 1, j + 1)});
                    } else {
                        do_color({mp(i, j), mp(i, j + 1)});
                    }
                } else {
                    if (b[i][j] && go[b[i][j]]) {
                        do_color({mp(i, j), mp(i, j + 1), mp(i + 1, j), mp(i + 1, j + 1)});
                    } else {
                        do_color({mp(i, j), mp(i, j + 1)});
                    }
                }
            }
        }
    }
    cout << ans << "\n";
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cout << answ[i][j];
        }
        cout << "\n";
    }
    return 0;
}
