﻿#include <iostream>
#include <algorithm>
#include <string>
#include <sstream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <map>
#include <functional>
#include <stack>
#include <cmath>
#include <cstring>
#include <random>
#include <chrono>
#include <memory>
#include <cassert>
#include <numeric>
#include <array>
#include <list>
#include <iomanip>
#include <bitset>
#define int long long
#define pii pair<int, int>
#define pic pair<int, char>
#define pdd pair<double, double>
#define pib pair<int, bool>
#define x first
#define y second
#define ll long long
#define ull unsigned long long
#define endl "\n"
#define all(a) (a).begin(), (a).end()
#define Mat vector<vector<long long>>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse,sse2,sse3,sse4")
//#pragma GCC target ("avx2")

using namespace std;

const int N = 1e6 + 10;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int q;
int n;
int a[N];
int b[N];

struct cmp1
{
	bool operator()(int i, int j) const 
	{
		return make_pair(a[i], i) > make_pair(a[j], j);
	}
};

struct cmp2
{
	bool operator()(int i, int j) const 
	{
		return make_pair(b[i], i) > make_pair(b[j], j);
	}
};

bool check()
{
	set<int, cmp1> sta;
	set<int, cmp2> stb;

	for (int i = 0; i < n; ++i)
	{
		sta.insert(i);
		stb.insert(i);
	}

	while (true)
	{
		int i = *sta.begin();
		auto it = stb.begin();
		
		if (*it == i)
			++it;

		if (it == stb.end())
			break;

		int j = *it;

		sta.erase(i);
		stb.erase(j);

		int dlt = min(a[i], b[j]);

		if (!dlt)
			break;

		a[i] -= dlt;
		b[j] -= dlt;
		sta.insert(i);
		stb.insert(j);
	}

	int cnt = 0;

	for (int i = 0; i < n; ++i)
		if (b[i] > 0)
			++cnt;

	if (cnt > 2)
		return false;

	if (!cnt)
		return true;

	if (cnt == 1)
	{
		int val = 0;
		int sum = 0;

		for (int i = 0; i < n; ++i)
			if (b[i] > 0)
				val = b[i];
			else
				sum += a[i];

		if (val > sum)
			return false;

		return true;
	}
	else
	{
		int val1 = -1, val2 = 0;
		int vala1 = 0, vala2 = 0;
		int sum = 0;

		for (int i = 0; i < n; ++i)
			if (b[i] > 0)
			{
				if (val1 == -1)
				{
					val1 = b[i];
					vala1 = a[i];
				}
				else
				{
					val2 = b[i];
					vala2 = a[i];
				}
			}
			else
				sum += a[i];


		val1 -= vala2;
		val2 -= vala1;
		val1 = max(0ll, val1);
		val2 = max(0ll, val2);
		

		if (val1 + val2 > sum)
			return false;

		return true;
	}
	
	return true;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//cout.precision(20);

	cin >> q;

	while (q--)
	{
		cin >> n;

		for (int i = 0; i < n; ++i)
			cin >> a[i];

		int mxb = 0;

		for (int i = 0; i < n; ++i)
		{
			cin >> b[i];
			mxb = max(mxb, b[i]);
		}

		for(int i = 0; i < n; ++i)
			if (b[i] == mxb)
			{
				b[i] = 0;
				break;
			}

		if (check())
			cout << "YES" << endl;
		else
			cout << "NO" << endl;
	}
}
