/**
 *    author:  tourist
 *    created: 09.05.1945 00:43:00
**/
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define fi first
#define se second
#define pb emplace_back
#define all(x) x.begin(),x.end()
#define re return
#define mp make_pair
#define sz(x) ((int)(x).size())
#define rep(i, n) for (int i = 0; i < (n); i++)
#define rrep(i, n) for (int i = (n) - 1; i >= 0; i--)
#define sqr(x) ((x)*(x))

#define in(x); { for (auto &qwertyuiop : x) cin >> qwertyuiop; }
#define out(x); { for (auto qwertyuiop : x) cout << qwertyuiop << ' '; cout << endl; }
#define unq(x); { sort(x.begin(), x.end()); x.resize(unique(x.begin(), x.end()) - x.begin()); }

//#define endl '\n'

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")

//#define int long long

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<string> vs;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef pair<double, double> pdd;
typedef double D;
typedef complex<double> cmp;

typedef pair <short, short> pss;

typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<vector<bool>> vvb;
typedef vector<vector<char>> vvc;

double getTime() { return clock() / (double) CLOCKS_PER_SEC;};
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int mod = 1e9 + 7;
const ll INF = 3e18;
const int N = 1e5 + 5;
const int base0 = 437;
const int base1 = 343;
const int d = 400;
const D pi = acos(-1);
const long double eps = 1e-4;

vi g[2000000];
char a[2000][2000];
bool use[2000000];
bool was[2000000];
ii lu[2000000];
int n, m;

int id(int i, int j) {
    return i * m + j;
}

vi path;
bool dfs(int v) {
    //cout << "go " << v << endl;
    was[v] = true;
    if (v >= n * m) path.pb(v);
    for (int i : g[v]) {
        if (!was[i]) dfs(i);
    }
}

char num[2000][2000];
char ans[2000][2000];
int cnt;

void razl(int x) {
    cnt++;
    int i = lu[x].fi, j = lu[x].se;
    //cout << "razl " << x << " " << i << ' '  << j << ' ' << num[i][j] << endl;
    if (a[i + 1][j] == a[i][j]) {
        if ('a' <= a[i][j])
            ans[i][j] = ans[i + 1][j] = ans[i][j - 1] = ans[i + 1][j - 1] = num[i - 1][j];
        else
            ans[i][j] = ans[i + 1][j] = ans[i][j + 1] = ans[i + 1][j + 1] = num[i][j];
    } else {
        if ('a' <= a[i][j])
            ans[i][j] = ans[i][j + 1] = ans[i - 1][j] = ans[i - 1][j + 1] = num[i][j];
        else
            ans[i][j] = ans[i + 1][j] = ans[i][j + 1] = ans[i + 1][j + 1] = num[i][j];
    }
}

void solve()
{
    cin >> n >> m;
    rep(i, n) {
        rep(j, m)
        {
            cin >> a[i][j];
        }
    }

    int st = 0;
    rep(i, n)
    {
        rep(j, m)
        {
            num[i][j] = (st + (j % 3)) + '0';
        }
        st = (st + 3) % 9;
    }

    int ff = n * m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m - 1; j++) {
            if (a[i][j] != '.' && a[i][j] == a[i][j + 1]) {
                ans[i][j] = ans[i][j + 1] = num[i][j];
                if ('a' <= a[i][j] && i > 0) {
                    if (a[i - 1][j] != '.' || a[i - 1][j + 1] != '.') continue;
                    g[ff].pb(id(i - 1, j));
                    g[ff].pb(id(i - 1, j + 1));
                    g[id(i - 1, j + 1)].pb(ff);
                    g[id(i - 1, j)].pb(ff);
                    lu[ff] = mp(i, j);
                    ff++;
                } else if (i < n - 1) {
                    if (a[i + 1][j] != '.' || a[i + 1][j + 1] != '.') continue;
                    g[ff].pb(id(i + 1, j));
                    g[ff].pb(id(i + 1, j + 1));
                    g[id(i + 1, j + 1)].pb(ff);
                    g[id(i + 1, j)].pb(ff);
                    lu[ff] = mp(i, j);
                    ff++;
                }
            }
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n - 1; i++) {
            if (a[i][j] != '.' && a[i][j] == a[i + 1][j]) {
                ans[i][j] = ans[i + 1][j] = num[i][j];
                if ('a' <= a[i][j] && j > 0) {
                    if (a[i][j - 1] != '.' || a[i + 1][j - 1] != '.') continue;
                    g[ff].pb(id(i, j - 1));
                    g[ff].pb(id(i + 1, j - 1));
                    g[id(i + 1, j - 1)].pb(ff);
                    g[id(i, j - 1)].pb(ff);
                    lu[ff] = mp(i, j);
                    ff++;
                } else if (j < m - 1) {
                    if (a[i][j + 1] != '.' || a[i + 1][j + 1] != '.') continue;
                    g[ff].pb(id(i, j + 1));
                    g[ff].pb(id(i + 1, j + 1));
                    g[id(i + 1, j + 1)].pb(ff);
                    g[id(i, j + 1)].pb(ff);
                    lu[ff] = mp(i, j);
                    ff++;
                }
            }
        }
    }

//    for (int i = 0; i <= 20; i++) {
//        for (int j : g[i])
//            cout << j << ' ';
//        cout << endl;
//    }


    for (int i = 0; i < n * m; i++) {
        if (!was[i] && g[i].size() == 1) {
            path.clear();
            dfs(i);
//            cout << "done" << endl;
            for (int j = 0; j < path.size(); j += 2)
                razl(path[j]);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (!was[i] && g[i].size() == 2) {
            path.clear();
            dfs(i);
//            cout << "done cycle" << endl;
            path.pop_back();
            for (int j = 0; j < path.size(); j += 2)
                razl(path[j]);
        }
    }

    cout << cnt << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (ans[i][j] == 0)
                cout << '.';
            else cout << ans[i][j];
        }
        cout << '\n';
    }
}

signed main()
{
//    freopen("input.txt ", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int qq = 1;
    //cin >> qq;
    while(qq--)
        solve();
}

//4 4
//.AA.
//A..a
//A..a
//.aa.

