#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll greedy(vector<pair<ll, pair<ll, ll>>>& a, ll need, vector<ll>& sol) {
    if (a.size() == 0) return 0;
    int n = a.size();

    ll have = 0, cost = 0;
    for (int i = 0; i < n; ++i) {
        if (have + a[i].second.first <= need) {
            have += a[i].second.first;
            cost += a[i].first;
            sol.push_back(a[i].second.second);
        }
    }
    return cost;
}

ll rndch(vector<pair<ll, pair<ll, ll>>>& a, ll need, vector<ll>& sol) {
    if (a.size() == 0) return 0;

    int pos = rand() % a.size();
    ll have = 0, cost = 0;
    have += a[pos].second.first;
    cost += a[pos].first;
    sol.push_back(a[pos].second.second);

    for (int i = 0; i < a.size(); ++i) {
        if (i == pos) continue;
        if (have + a[i].second.first <= need) {
            have += a[i].second.first;
            cost += a[i].first;
            sol.push_back(a[i].second.second);
        }
    }
    return cost;
}

void solve() {
    ll n, w;
    cin >> n >> w;

    vector<pair<ll, pair<ll, ll>>> a;
    for (int i = 0; i < n; ++i) {
        ll w, c;
        cin >> w >> c;

        a.push_back({c, {w, i}});
    }

    ll www = 3 * w / 2;
    vector<ll> sol, temp;
    ll ans = greedy(a, www, sol);
    auto check = [&](ll x) {
        temp.clear();
        ll res = greedy(a, x, temp);
        if (res > ans) {
            ans = res;
            sol = temp;
        }
    };

    auto rev = [&]() {
        for (int i = 0; i < a.size(); ++i)
            a[i].second.first *= -1;
        sort(a.rbegin(), a.rend());
        for (int i = 0; i < a.size(); ++i)
            a[i].second.first *= -1;
    };

    sort(a.begin(), a.end());
    check(www);
    check(w);
    rev();
    check(www);
    check(w);

    srand(time(NULL));
    for (int i = 0; i < 200; ++i) {
        random_shuffle(a.begin(), a.end());
        check(www);
        check(w);
    }

    vector<pair<ll, pair<ll, ll>>> bbbb;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].second.first <= w)
            bbbb.emplace_back(a[i]);
    }
    a = bbbb;

    sort(a.begin(), a.end());
    check(www);
    check(w);
    rev();
    check(www);
    check(w);
    for (int i = 0; i < 200; ++i) {
        random_shuffle(a.begin(), a.end());
        check(www);
        check(w);
    }

    cout << sol.size() << '\n';
    for (int i : sol)
        cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve ();

    return 0;
}



