/*#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <math.h>
#include <map>
#include <chrono>
#include <set>
#include <stack>
#include <vector>
#include <time.h>
#include <random>
#include <algorithm>
#include <string>
#include <string.h>
#include <queue>
#include <deque>
#include <functional>
#include <cctype>
#include <list>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <complex>
#define endl '\n'
#define all(a) (a).begin(), (a).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
mt19937 rng(time(0));
uniform_int_distribution<int> uid(-1000000000, 1000000000);

ll n, a, b, s;
vector<pair<int, int> > v;

bool cmp(pair<int, int> a, pair<int, int> b) {
	return a.first > b.first;
}

int main1() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(40);
	int t;
	bool f;
	cin >> t;
	while (t--) {
		cin >> n;
		s = 0;
		v.resize(n, { 0,0 });
		for (int i = 0; i < n; ++i) {
			cin >> v[i].second;
			s = s + v[i].second;
		}
		for (int i = 0; i < n; ++i) {
			cin >> v[i].first;
		}
		sort(v.begin(), v.end(), cmp);
		if (n == 2) {
			if (v[0].first < v[1].second || v[1].first < v[0].second)
				cout << "YES";
			else
				cout << "NO";
			cout << endl;
			continue;
		}
		f = true;
		for (int i = 1; i < n; ++i) {
			s = s - v[i].second;
			if (s < v[i].first && s != 0) {
				f = false;
				break;
			}
			s = s - v[i].first + v[i].second;
		}
		if (f)
			cout << "YES";
		else
			cout << "NO";
		cout << endl;
	}
	
	return 0;
}
*/
#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <sstream>
#include <iomanip>
#include <math.h>
#include <map>
#include <chrono>
#include <set>
#include <stack>
#include <vector>
#include <time.h>
#include <random>
#include <algorithm>
#include <string>
#include <string.h>
#include <queue>
#include <deque>
#include <functional>
#include <cctype>
#include <list>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <complex>
#define endl '\n'
#define all(a) (a).begin(), (a).end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
mt19937 rng(time(0));
uniform_int_distribution<int> uid(-1000000000, 1000000000);

int n;
ll s;
vector<pll > v;

bool cmp(pair<int, int> a, pair<int, int> b) {
	if (a.first == b.first)
		return a.second > b.second;
	return a.first > b.first;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(40);
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		v.resize(n, { 0, 0 });
		for (int i = 0; i < n; ++i) {
			cin >> v[i].second;
		}
		for (int i = 0; i < n; ++i) {
			cin >> v[i].first;
		}
		sort(v.begin(), v.end(), cmp);
		s = v[0].second;
		int i = 1, j;
		bool f = true;
		while (i < n) {
			if (i + 1 == n) {
				if (s >= v[i].first)
					f = true;
				else
					f = false;
				break;
			}
			j = i + 1;
			while (v[j].second < v[i].first) {
				v[i].first = v[i].first - v[j].second;
				v[j].second = 0;
				++j;
				if (j == n) {
					break;
				}
			}
			if (j == n) {
				if (s >= v[i].first) {
					s = s - v[i].first;
				}
				else {
					f = false;
					break;
				}
				s = s + v[i].second;
				++i;
				continue;
			}
			v[j].second = v[j].second - v[i].first;
			s = s + v[i].second;
			++i;
		}
		if (f)
			cout << "YES";
		else
			cout << "NO";
		cout << endl;
	}

	return 0;
}