#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 1e6 + 66;
int good[1111][1111];
int n, m;
char c[1222][1222];
int r[1222][1222];
int get(int i, int j) {
	return (i - 1) * m + j - 1;
}
pair<int,int> rev(int x) {
	int i = x / m;
	return {i + 1, x % m + 1};
}

int cycle, used[1111], R;
vector<int> g[N];
vector<int> cc;
void dfs(int i, int p = -1) {
	//cout << rev(i).first << " " << rev(i).second << " go\n";
	used[i] = 1;
	cc.push_back(i);
	for (int to : g[i]) if (to != p) {
		if (used[to]) cycle = 1;
		else dfs(to, i);
	}
}
int ans = 0, k[1111][1111];
void notcool(int i, int j) {
	//cout << i << " " << j << " not cooling\n";
	if (isupper(c[i][j])) {
		if (i < n && c[i + 1][j] == c[i][j] && !r[i + 1][j]) {
			r[i][j] = ++R;
			r[i + 1][j] = R;
		} else if (j < m && c[i][j + 1] == c[i][j] && !r[i][j + 1]) {
			r[i][j] = ++R;
			r[i][j + 1] = R;
		}
	} else {
		if (i > 1 && c[i - 1][j] == c[i][j] && !r[i - 1][j]) {
			r[i][j] = ++R;
			r[i - 1][j] = R;
		} else if (j > 1 && c[i][j - 1] == c[i][j] && !r[i][j - 1]) {
			r[i][j] = ++R;
			r[i][j - 1] = R;
		}
	}

}
void cool(int x) {
	int i = rev(x).first, j = rev(x).second;
	//cout << i << " " << j << " cooling\n";
	if (isupper(c[i][j])) {
		if (i < n && c[i + 1][j] == c[i][j] && !r[i][j + 1] && !r[i + 1][j + 1]) {
			r[i][j + 1] = ++R;
			r[i + 1][j + 1] = R;
			r[i][j] = R;
			r[i + 1][j] = R;
			ans++;
		} else if (j < m && c[i][j + 1] == c[i][j] && !r[i + 1][j] && !r[i + 1][j + 1]) {
			r[i + 1][j] = ++R;
			r[i + 1][j + 1] = R;
			r[i][j] = R;
			r[i][j + 1] = R;
			ans++;
		}
	} else {
		if (i > 1 && c[i - 1][j] == c[i][j] && !r[i][j - 1] && !r[i - 1][j - 1]) {
			r[i][j - 1] = ++R;
			r[i - 1][j - 1] = R;
			r[i][j] = R;
			r[i - 1][j] = R;
			ans++;
		} else if (j > 1 && c[i][j - 1] == c[i][j] && !r[i - 1][j] && !r[i - 1][j - 1]) {
			r[i - 1][j] = ++R;
			r[i - 1][j - 1] = R;
			r[i][j] = R;
			r[i][j - 1] = R;
			ans++;
		}
	}

}

vector<pair<int,int>> v[1111][1111];
map<pair<int,int>,int> cnt[1111][1111];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cin >> n >> m;
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			cin >> c[i][j];
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (c[i][j] == '.') continue;
			if (isupper(c[i][j])) {
				if (i < n && c[i + 1][j] == c[i][j]) {
					if (c[i][j + 1] != '.' || c[i + 1][j + 1] != '.') continue;
					v[i][j + 1].push_back({i, j});
					v[i + 1][j + 1].push_back({i, j});
					good[i][j] = 1;
				} else if (j < m && c[i][j + 1] == c[i][j]) {
					if (c[i + 1][j] != '.' || c[i + 1][j + 1] != '.') continue;
					v[i + 1][j].push_back({i, j});
					v[i + 1][j + 1].push_back({i, j});
					good[i][j] = 1;
				}
			} else {
				if (i > 1 && c[i - 1][j] == c[i][j]) {
					if (c[i][j - 1] != '.' || c[i - 1][j - 1] != '.') continue;
					v[i][j - 1].push_back({i, j});
					v[i - 1][j - 1].push_back({i, j});
					good[i][j] = 1;
				} else if (j > 1 && c[i][j - 1] == c[i][j]) {
					if (c[i - 1][j] != '.' || c[i - 1][j - 1] != '.') continue;
					v[i - 1][j].push_back({i, j});
					v[i - 1][j - 1].push_back({i, j});
					good[i][j] = 1;
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			for (auto a : v[i][j]) {
				for (auto b : v[i][j]) {
					if (a == b) continue;
					cnt[a.first][a.second][b]++;
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			for (auto C : cnt[i][j]) {
				if (C.second == 4) {
					cool(get(i, j));
					break;
				} else {
					g[get(i, j)].push_back(get(C.first.first, C.first.second));
					g[get(C.first.first, C.first.second)].push_back(get(i, j));
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (!used[get(i, j)] && int(g[get(i, j)].size()) == 2 && good[i][j] ) {
				cycle = 0;
				cc.clear();
				dfs(get(i, j));
				int sz = cc.size();
				if (sz % 2 == 1 && cycle) {
					cc.pop_back();
					sz--;
				}
				for (int k = 0 ; k < sz ; k += 2) {
					cool(cc[k]);
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (!used[get(i, j)] && good[i][j]) {
				cycle = 0;
				cc.clear();
				dfs(get(i, j));
				int sz = cc.size();
				if (sz % 2 == 1 && cycle) {
					cc.pop_back();
					sz--;
				}
				for (int k = 0 ; k < sz ; k += 2) {
					cool(cc[k]);
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (!r[i][j] && good[i][j]) cool(get(i, j));
			if (!r[i][j] && c[i][j] != '.') notcool(i, j);
		}
	}
	//cout << ans << "\n";
	//for (int i = 1 ; i <= n ; ++ i) {
		//for (int j = 1 ; j <= m ; ++ j) {
			//cout << r[i][j];
		//}
		//cout << "\n";
	//}
	//cout << "====\n";
	vector<int> vec;
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (r[i][j] == 0 || k[i][j] != 0) continue;
			vec = {0};
			for (int x = 0 ; x <= 1 ; ++ x) {
				for (int y = 0 ; y <= 1 ; ++ y) {
					int nx = i + x, ny = j + y;
					if (r[nx][ny] == r[i][j]) {
						for (int dx = -1 ; dx <= 1 ; ++ dx) {
							for (int dy = -1 ; dy <= 1 ; ++ dy) {
								int ni = nx + dx, nj = ny + dy;
								if (1 <= i && ni <= n && 1 <= nj && nj <= m && r[ni][nj] != 0) {
									vec.push_back(k[ni][nj]);
								}
							}
						}
					}
				}
			}
			//cout << i << " " << j << " ---\n";
			//for (int qqq : vec) cout << qqq << " ";
			//cout << "---\n";
			sort(vec.begin(), vec.end());
			vec.resize(unique(vec.begin(), vec.end()) - vec.begin());
			int sz = vec.size();
			for (int z = 1 ; z < sz ; ++ z) {
				if (vec[z] - vec[z - 1] > 1) {
					k[i][j] = vec[z - 1] + 1;
				}
			}
			if (k[i][j] == 0) k[i][j] = vec.back() + 1;
			for (int x = 0 ; x <= 1 ; ++ x) {
				for (int y = 0 ; y <= 1 ; ++ y) {
					int nx = i + x, ny = j + y;
					if (r[nx][ny] == r[i][j]) {
						//cout << nx << " " << ny << " from " << i << " " << j << " " << k[i][j] << "\n";
						k[nx][ny] = k[i][j];
					}
				}
			}
		}
	}
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= m ; ++ j) {
			if (r[i][j] == 0) {
				cout << ".";
				continue;
			}
			cout << k[i][j] - 1;
		}
		cout << '\n';
	}
}

