//order_of_key(k): Number of items strictly smaller than k .
//find_by_order(k): K-th element in a set (counting from zero).
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define full(x,n) x,x+n+1
#define full(x) x.begin(),x.end()
#define finish return 0

#define putb push_back
#define f first
#define s second

//logx(a^n)=loga(a^n)/logx(a)
//logx(a*b)=logx(a)+logx(b)
//logx(y)=log(y)/log(x)
//logb(n)=loga(n)/loga(b)

#define ordered_set tree<ll,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update>
#define putf push_front
#define gainb pop_back

//(a+b)^n=sum of C(n,i)*a^i*b^(n-i) 0<=i<=n
//(a-b)^n=sum of C(n,i)*a^i*b^(n-i) for even i-for odd i

#define gainf pop_front
#define len(x) (int)x.size()

// 1/b%mod=b^(m-2)%mod
// (a>>x)&1==0
// a^b=(a+b)-2(a&b)

typedef double db;
typedef long long ll;

//sum of squares n*(n+1)*(2n+1)/6
//sum of cubes [n*(n+1)/2]^2
//sum of squares for odds n*(4*n*n-1)/3
//sum of cubes for odds n*n*(2*n*n-1)

const int ary=2e5+5;
const int mod=1e9+7;
const ll inf=1e18;

using namespace std;
using namespace __gnu_pbds;
int tt,n,a[ary],b[ary],t[4*ary];
void build(int v=1,int tl=1,int tr=n){
	if(tl==tr){
		t[v]=tl;
		return;
	}
	int tm=(tl+tr)/2;
	build(v*2,tl,tm);
	build(v*2+1,tm+1,tr);
	if(b[t[v*2+1]]==0){
		t[v]=t[v*2];
		return;
	}
	if(b[t[v*2]]==0){
		t[v]=t[v*2+1];
		return;
	}
	if(b[t[v*2]]<=b[t[v*2+1]]){
		t[v]=t[v*2];
		return;
	}
	t[v]=t[v*2+1];
}
void upd(int p,int x,int v=1,int tl=1,int tr=n){
	if(tr<p||tl>p){
		return;
	}
	if(tl==tr){
		b[tl]-=x;
		return;
	}
	int tm=(tl+tr)/2;
	upd(p,x,v*2,tl,tm);
	upd(p,x,v*2+1,tm+1,tr);
	if(b[t[v*2+1]]==0){
		t[v]=t[v*2];
		return;
	}
	if(b[t[v*2]]==0){
		t[v]=t[v*2+1];
		return;
	}
	if(b[t[v*2]]<=b[t[v*2+1]]){
		t[v]=t[v*2];
		return;
	}
	t[v]=t[v*2+1];
}
int get(int l,int r,int v=1,int tl=1,int tr=n){
	if(tr<l||tl>r||l>r){
		return 0;
	}
	if(tl==tr){
		return t[v];
	}
	int tm=(tl+tr)/2;
	int x=get(l,r,v*2,tl,tm);
	int y=get(l,r,v*2+1,tm+1,tr);
	if(!b[y]){
		return x;
	}
	if(!b[x]){
		return y;
	}
	if(b[x]<=b[y]){
		return x;
	}
	return y;
}
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	cin>>tt;
	while(tt--){
		cin>>n;
		for(int i=1;i<=n;i++){
			cin>>a[i];
		}
		for(int j=1;j<=n;j++){
			cin>>b[j];
		}
		b[n+1]=0;
		build();
		for(int i=1;i<=n;i++){
			while(a[i]){
				int x=get(1,i-1);
				int y=get(i+1,n);
				if(b[y]==0&&b[x]==0){
					break;
				}
				int z=0;
				if(b[y]==0){
					z=x;
				}
				if(b[x]==0){
					z=y;
				}
				if(b[y]&&b[x]){
					if(b[x]<=b[y]){
						z=x;
					}
					else{
						z=y;
					}
				}
				if(b[z]<=a[i]){
					upd(z,b[z]);
					a[i]-=b[z];
				}
				else{
					upd(z,a[i]);
					a[i]=0;
				}
			}
		}
		int cnt=0;
		for(int i=1;i<=n;i++){
			if(b[i]){
				cnt++;
			}
		}
		if(cnt<=1){
			cout<<"YES";
		}
		else{
			cout<<"NO";
		}
		cout<<"\n";
	}
}
