#include <bits/stdc++.h>	
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define ld long double
#define pii pair <int, int>
#define sz(a) (int)(a.size()) 
#define resize(v) v.resize(unique(all(v)) - v.begin()); 
#define all(a) a.begin(), a.end()
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it ++)
#define int long long

// random_device rd; mt19937 g(rd());    
                                        	
using namespace std;
using namespace __gnu_pbds;
 
void Fast_Read_Out()
{
    ios_base::sync_with_stdio(0);
    cin.tie(), cout.tie();
}
 
void Random()
{
    unsigned int seed;                                                                        
    asm("rdtsc" : "=A" (seed));
    srand(seed);        
}
 
unsigned int Time()
{
     unsigned int time = clock() / 1000.00;                           
     return time;
}

template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>; 
 
const int mod = (int)1e9 + 7;
const int maxn = (int)6e5 + 123;

int n, m, s, a[maxn], len;
set <int> r;
vector <int> v, L, R;
int t[maxn * 4], add[maxn * 4];
 
void push(int tl, int tr, int v)
{
	if(add[v] == -mod) return;
	if(tl != tr)
	{
		add[v + v] = add[v];
		add[v + v + 1] = add[v];
	}
	t[v] = 1LL * (tr - tl + 1) * add[v];
	add[v] = -mod;
}
 
int Get(int l, int r, int tl = 0, int tr = maxn, int v = 1)
{
	if(!v || tl > r || l > tr || l > r || tl > tr) return 0;
	push(tl, tr, v);
	if(l <= tl && tr <= r) return t[v];
	int tm = (tl + tr) / 2;
	return Get(l, r, tl, tm, v + v) + Get(l, r, tm + 1, tr, v + v + 1);
} 
 
void Update(int l, int r, int val, int tl = 0, int tr = maxn, int v = 1)
{
	push(tl, tr, v);
	if(l > tr || tl > r || tl > tr) return;
	if(l <= tl && r >= tr)
	{                   
		add[v] = val;
		push(tl, tr, v);
		return;
	}
	int tm = (tl + tr) / 2;
	Update(l, r, val, tl, tm, v + v);
	Update(l, r, val, tm + 1, tr, v + v + 1);
	t[v] = t[v + v] + t[v + v + 1];
}


main ()
{
/*
	#ifdef JUDGE
		freopen("input.txt", "r", stdin);
	#endif */
	Fast_Read_Out();
	Random();

	cin >> n >> m >> s;
	for (int i = 1; i <= m; i++) {
		int x;
		cin >> x;
		r.insert(x);
	}
   	while (!r.empty()) {
   		a[++len] = *r.begin();
		r.erase(r.begin());			
   	}
   	if (m - s > len or m > n) {
   		cout << 0 << endl;
   		exit(0);
   	}
   	for (int i = 1; i <= len; i++) {
  		int j = i + m - s - 1ll;
  		if (j <= len)
  			if (a[j] - a[i] <= m - 1ll) {
  				int t = abs(a[j] - a[i] - m + 1ll);
  				int l = max(1ll, a[i] - t), r = min(a[i], n - m + 1ll);
  				if(l > r) swap(l, r);
  				for(int k = -1ll; k <= 1ll; k++) v.pb(l + k), v.pb(r + k);
  				L.pb(l), R.pb(r);
  			}
   	}
	sort(all(v));
	resize(v);
	for(int i = 0; i < sz(L); i++)
	{
		L[i] = lower_bound(all(v), L[i]) - v.begin() + 1ll;
		R[i] = lower_bound(all(v), R[i]) - v.begin() + 1ll;
		Update(L[i], R[i], 1);
	} 
  	cout << Get(0, maxn);

}      