#pragma comment(linker, "/stack:20000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#pragma GCC target("avx,avx2,fma")
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <set>
#include <queue>
#include <map>
#include <stack>
#define ll long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
#include <x86intrin.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int , null_type, less< int >, rb_tree_tag,tree_order_statistics_node_update> order_set;
const int INF = (int)(1e9 + 7);
long double Pi = acos(-1.0);
long double Eps = (long double)(1e-12);
struct point{
    double x, y;
    point(){};
    point(double a, double b){
        x = a;
        y = b;
    }
    point operator - (point a){
        return point(x - a.x, y - a.y);
    }
    double operator % (point a){
        return x * a.y - y * a.x;
    }
    double operator * (point a){
        return x * a.x + y * a.y;
    }
    double dist(point a){
        double dx = a.x - x, dy = a.y - y;
        return dx * dx + dy * dy;
    }
};
struct line{
    double a, b, c;
    line(){};
    line(double x, double y, double z){
        a = x;
        b = y;
        c = z;
    }
    line(point x, point y){
        a = y.y - x.y;
        b = x.x - y.x;
        c = y.x * x.y - x.x * y.y;
    }
    bool point_belongs(point x){
        return (a * x.x + b * x.y + c == 0);
    }
};
unsigned ll bin_pow(int base, int pow){
    if(pow == 0){
        return 1;
    }
    if(pow == 1){
        return base;
    }
    if(pow & 1){
        return bin_pow(base, pow - 1) * base;
    }
    unsigned ll half = bin_pow(base, pow / 2);
    return half * half;
}
string ans = "";
bool curr[20];
void rec(int pos, int goal){
    //cout << '\t' << pos << ' ' << goal << '\n';
    if(pos == goal){
        for(int i = 0; i < goal; i ++){
            if(curr[i]){
                ans += '1';
            }
            else{
                ans += '0';
            }
        }
        //cout << ans << '\n';
        return;
    }
    curr[pos] = false;
    rec(pos + 1, goal);
    curr[pos] = true;
    rec(pos + 1, goal);
    return;
}
int main(){
    srand(time(0));
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    //cout.precision(20);
    int n, len;
    cin >> n;
    len = (1 << n);
    if(n == 20){
        rec(0, 20);
        cout << ans;
    }
    else if(n >= 11){
        rec(0, 8);
        while(ans.size() != len){
            if(rand() % 3){
                ans += '0';
            }
            else{
                ans += '1';
            }
        }
        cout << ans;
    }
    else if(n >= 6){
        rec(0, 4);
        while(ans.size() != len){
            if(rand() % 3){
                ans += '0';
            }
            else{
                ans += '1';
            }
        }
        cout << ans;
    }
    else if(n >= 3){
        rec(0, 2);
        while(ans.size() != len){
            if(rand() % 3){
                ans += '0';
            }
            else{
                ans += '1';
            }
        }
        cout << ans;
    }
    else if(n == 2){
        cout << "1001";
    }
    else{
        cout << "10";
    }
    //fclose(stdin);
    //fclose(stdout);
    return 0;
}
