/*
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")
ordered_set -> less -> less_equal
ordered_set find_by_order(k) -> k element
ordered_set order_of_key(k) -> returns the number of elements in a set strictly smaller than k
*/
#include <bits/stdc++.h>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T> using ordered_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const long long maxn = 1e6 + 123;
const long long inf = 1e9 + 7;
const long long linf = 1e18 + 123;
const long long mod = 1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1);
int dx[8] = {0, 1, -1, 0, 1, -1, 1, -1};
int dy[8] = {1, 0, 0, -1, 1, 1, -1, -1};

int a[maxn];

int main(){
    //freopen("input.cpp", "r", stdin);
   	//freopen("output.cpp", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    set<int> v;
    for (int i = 1 ;i <= m; i++){
    	cin >> a[i];
    	v.insert(a[i]);
    }
    int size = v.size(), id = 0;
    for (auto i : v){
    	id++;
    	a[id] = i; 
    }
    a[size + 1] = inf;
    long long ans = 0;
    for (int l = max(1, a[1] - s); (l + m - 1) <= min(a[size] + s, n); l++){
    	int id = upper_bound(a + 1, a + 2 + size, l + m - 1) - a - 1;
    	int id1 = upper_bound(a + 1, a + 2 + size, l - 1) - a - 1;
    	//cout << l << " " << l + m - 1 << " " << id << " " << id1 << "\n";
    	if (m - (id - id1) <= s){
    		ans++;
    	}
    }
    cout << ans;
    exit(0);
}
