#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <stack>
#include <map>
#include <string>
#include <math.h>
#include <cassert>
#include <set>
using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#ifdef QWERTY
#define db(x) cerr <<#x << " = " << x << endl
#else
#define db(x) 42
#endif

typedef long long ll;

#define N 200200

set<string> ans;
void build(string s) {
	ans.insert(s);
	int len = s.size();
	if (len == 1) return;

	string s1, s2;
	for (int i = 0; i < len; i++) {
		if (i < len / 2) s1 += s[i]; else
			s2 += s[i];
	}

	build(s1);
	build(s2);
}

string s[25];

void solve(int TC) {
	int n;
	cin >> n;

	s[1] = "10";
	s[2] = "1001";
	s[3] = "00100111";

	for (int i = 4; i <= n; i++) {
		int x = (1 << 1);
		int y = (1 << (i - 1)) / x;
		s[i] = s[i - 1];
		for (int j = x; j < (y - 1) * x; j++) {
			s[i] += s[i - 1][j];
		}
		for (int j = 0; j < x; j++) {
			s[i] += s[i - 1][j];
		}
		for (int j = (y - 1) * x; j < y * x; j++) {
			s[i] += s[i - 1][j];
		}
	}

	build(s[n]);
	cout << ans.size() << endl;

	cout << s[n];

}

int main() {
#ifdef QWERTY
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
#endif 
	int TC = 1;
	//cin >> TC;


	for (int i = 1; i <= TC; i++)
		solve(i);


	return 0;
}