#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

signed main()
{
	ll t; cin >> t;
	while (t--)
	{
		ll n; cin >> n;
		vector<ll> a(n), b(n);
		ll sa = 0, sb = 0;
		for (ll i = 0; i < n; ++i)
		{
			cin >> a[i];
			sa += a[i];
		}

		for (ll i = 0; i < n; ++i)
		{
			cin >> b[i];
			sb += b[i];
		}

		ll mans = inf;

		for (ll i = 0; i < n; ++i)
		{
			ll ans = sb - b[i];
			for (int j = 0; j < n; ++j)
			{
				if (j == i)
					ans -= min(sb - b[i], a[j]);
				else
					ans -= min(sb - b[i] - b[j], a[j]);
			}
			mans = min(mans, ans);
		}

		if (mans >= 1)
			cout << "NO\n";
		else
			cout << "YES\n";

	}




	return 0;
}