#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

signed main()
{
	ll n, m, s;
	cin >> n >> m >> s;

	vector<ll> a(m);
	for (ll i = 0; i < m; ++i)
		cin >> a[i];

	sort(a.begin(), a.end());
	a.erase(unique(a.begin(), a.end()), a.end());
	if (a.size() < m - s)
	{
		cout << 0;
		return 0;
	}
	ll ans = 0;
	for (ll i = 0; i + m - s - 1 < a.size(); ++i)
	{
		ll j = i + m - s - 1;
		if (a[j] - a[i] >= m)
			continue;

		if (i == 0)
		{
			ll k = max(1ll, a[j] - m + 1);
			ans += a[i] - k + 1;
		}
		else
		{
			ll k = max(max(1ll, a[j] - m + 1), a[i - 1] + 1);
			ans += a[i] - k + 1;
		}

	}
	cout << ans << '\n';
	cin >> n;

	return 0;
}