#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
string to_string(int val, int length)
{
    string ret = "";
    while(val > 0)
    {
        ret = (char)('0'+(val%2))+ret;
        val /= 2;
    }
    while(ret.length() < length) ret = "0"+ret;
    return ret;
}
int from_string(string s)
{
    int ans = 0;
    while(s.length() > 0)
    {
        ans+=(s[0]=='1');
        ans*=2;
        s = s.substr(1);
    }
    ans /= 2;
    return ans;
}
int main()
{
    int k;
    cin >> k;
    string ans = "01";
    int step = 2;
    while(ans.length() < (1<<k))
    {
        vector<int> used;
        for(int i = 0; i < ans.length(); i+=step)
            used.push_back(from_string(ans.substr(i,step)));
        sort(used.begin(), used.end());
        for(int i = 0; i < (1<<step); i++)
            if(used[lower_bound(used.begin(), used.end(), i)-used.begin()]!=i)
                ans = ans + to_string(i, step);
        step *= 2;
    }
    cout << ans.substr(0, 1<<k);
    return 0;
}
