#include "bits/stdc++.h"

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef unsigned int uint;
typedef long double ld;

#define PB push_back
#define EB emplace_back
#define F first
#define S second
#define MT make_tuple
#define MP make_pair

struct State{
    vector<int> a;
    
    bool operator<(const State &o) const {
        return a < o.a;
    }
};

int a[11];
int c[11][11];

map<State, int> r;

ostream &operator<<(ostream &out, const vector<int> &v) {
    out << "vector<int>: ";
    for (int i : v) out << i << ' ';
    return out;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ifstream fin("INPUT.TXT");
    ofstream fout("OUTPUT.TXT");
    int n;
    fin >> n;
    for (int i = 1; i <= n; i++) fin >> a[i];
    for (int y = 1; y <= n; y++) {
        for (int x = 1; x <= n; x++) fin >> c[y][x];
    }
    
    queue<State> q;
    State start;
    start.a.resize(n + 1);
    for (int i = 1; i <= n; i++) start.a[i] = a[i];
    q.push(start);
    while (!q.empty()) {
        State s = q.front();
        //cerr << s.a << '\n';
        for (int i = 1; i <= n; i++) {
            if (s.a[i] >= 2) {
                int t = r[s] + c[i][i];
                s.a[i] -= 2;
                if (r.count(s) == 0 || r[s] > t) {
                    r[s] = t;
                    q.push(s);
                }
                s.a[i] += 2;
            }
            for (int j = i + 1; j <= n; j++) {
                if (s.a[i] > 0 && s.a[j] > 0) {
                    int t = r[s] + c[i][j];
                    s.a[i]--;
                    s.a[j]--;
                    if (r.count(s) == 0 || r[s] > t) {
                        r[s] = t;
                        q.push(s);
                    }
                    s.a[i]++;
                    s.a[j]++;
                }
            }
        }
        q.pop();
    }
    State end;
    end.a.resize(n + 1);
    for (int i = 1; i <= n; i++) end.a[i] = 0;
    if (r.count(end) == 0) fout << -1;
    else fout << r[end];
    return 0;
}