#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3", "Ofast", "unroll-loopps", "unswitch-loops", "fast-math", "no-stack-protector")

/*


 */

#define all(x) (x).begin(), (x).end()
// #define size(x) (int)x.size()

typedef long long ll;
#define int long long

bool cmp(pair<int, pair<int, int> > x, pair<int, pair<int, int> > y) {
    ll a = (ll) x.second.second * (ll) y.second.first;
    ll b = (ll) x.second.first * (ll) y.second.second;
    if (a > b) return true;
    return false;
}

vector<pair<int, pair<int, int> > > sm;
vector<pair<int, pair<int, int> > > big;

vector<pair<ll, ll>> pref;

ll solve(ll w) {
    int l = -1;
    int r = sm.size();
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (pref[mid].first < w) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return pref[r].second;
}

void get_ans(int uk, ll w) {
    vector<int> ans;
    if (uk != big.size()) {
        ans.push_back(big[uk].first);
        w -= big[uk].second.first;
    }
    //cout << uk << " " << w << "\n";
    for (int i = 0; i < sm.size(); ++i) {
        ans.push_back(sm[i].first);
        if (pref[i+1].first >= w) break;
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n;
        ll W;
        cin >> n >> W;
        big.clear();
        sm.clear();
        pref.clear();
        for (int j = 0; j < n; ++j) {
            int x;
            int y;
            cin >> x >> y;
            if (x <= W / 2) {
                sm.push_back({j + 1, {x, y}});
            } else if (x <= W) {
                big.push_back({j + 1, {x, y}});
            }
        }

        sort(sm.begin(), sm.end(), cmp);
        pref.push_back({0, 0});
        for (int j = 0; j < sm.size(); ++j) {
            pair<ll, ll> a = {pref[pref.size() - 1].first, pref[pref.size() - 1].second};
            a.first += sm[j].second.first;
            a.second += sm[j].second.second;
            pref.push_back(a);
        }

        ll ans = 0;
        int uk = big.size();
        for (int j = 0; j < big.size() + 1; ++j) {
            ll cur = 0;
            ll sz = W;
            if (j != big.size()) {
                sz -= big[j].second.first;
                cur += big[j].second.second;
            }
            cur += solve(sz);
            if (cur > ans) {
                ans = cur;
                uk = j;
            }
        }
        get_ans(uk, W);
    }
}