#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

void solve() {
    int n;
    cin >> n;
    for (int level = n - 1; level >= 0; --level) {
        string s;
        for (int i = 0; i < (1ll << level); ++i) {
            string now;
            int len = (1ll << n) / (1ll << level);
            for (int j = 0; j < len; ++j) {
                now += ((i >> j) & 1) + '0';
            }
            reverse(now.begin(), now.end());
            s += now;
        }
        if (s.size() >= (1ll << n)) {
            cout << s.substr(0, (1ll << n)) << "\n";
            return;
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
