#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

struct pred {
    int last, p1, p2, null;
    pred() {}
    pred(int last, int p1, int p2, int null): last(last), p1(p1), p2(p2), null(null) {};
};

const int MAXN = 1000;
int d[MAXN][10][2][2][2];
int cnt[MAXN][10][2][2][2];
pred p[MAXN][10][2][2][2];

void solve() {
    memset(d, 0, sizeof(d));
    memset(cnt, 0, sizeof(cnt));
    memset(p, 0, sizeof(p));
    string l, r;
    cin >> l >> r;
    reverse(l.begin(), l.end());
    while (l.size() < r.size()) {
        l.push_back('0');
    }
    reverse(l.begin(), l.end());
    int n = l.size();
    for (int now = l[0] - '0'; now <= r[0] - '0'; ++now) {
        int p1 = (now > l[0] - '0' ? 1 : 0);
        int p2 = (now < r[0] - '0' ? 1 : 0);
        d[0][now][p1][p2][now != 0 ? 1 : 0] = 1;
        cnt[0][now][p1][p2][now != 0 ? 1 : 0] = 1;
    }
    for (int i = 1; i < n; ++i) {
        for (int now = 0; now < 10; ++now) {
            for (int prev = 0; prev < 10; ++prev) {
                for (int p1 = 0; p1 <= 1; ++p1) {
                    for (int pnull = 0; pnull <= 1; ++pnull) {
                        int null = pnull || (now != 0);
                        int add = null && (now == prev);
                        for (int p2 = 0; p2 <= 1; ++p2) {
                            int pn1 = p1 || (now > l[i] - '0');
                            int pn2 = p2 || (now < r[i] - '0');
                            if ((pn1 == 0 && now < l[i] - '0') || (pn2 == 0 && now > r[i] - '0')) {
                                continue;
                            }
                            if (d[i][now][pn1][pn2][null] < d[i - 1][prev][p1][p2][pnull] + add && d[i - 1][prev][p1][p2][pnull] != 0) {
                                d[i][now][pn1][pn2][null] = d[i - 1][prev][p1][p2][pnull] + add;
                                cnt[i][now][pn1][pn2][null] = 0;
                                p[i][now][pn1][pn2][null] = pred(prev, p1, p2, pnull);
                            }
                            if (d[i][now][pn1][pn2][null] == d[i - 1][prev][p1][p2][pnull] + add) {
                                cnt[i][now][pn1][pn2][null] += cnt[i - 1][prev][p1][p2][pnull];
                            }
                        }
                    }
                }
            }
        }
    }
    int x = 0, count = 0;
    int plast, pp1, pp2, pnull = 1;
    for (int last = 0; last < 10; ++last) {
        for (int p1 = 0; p1 <= 1; ++p1) {
            for (int p2 = 0; p2 <= 1; ++p2) {
                if (d[n - 1][last][p1][p2][1] > x) {
                    x = d[n - 1][last][p1][p2][1];
                    count = 0;
                    plast = last;
                    pp1 = p1;
                    pp2 = p2;
                }
                if (d[n - 1][last][p1][p2][1] == x) {
                    count += cnt[n - 1][last][p1][p2][1];
                }
            }
        }
    }
    string ans;
    for (int i = 0; i < n; ++i) {
        ans += (char)(plast + '0');
        pred pr = p[n - i - 1][plast][pp1][pp2][pnull];
        plast = pr.last;
        pp1 = pr.p1;
        pp2 = pr.p2;
        pnull = pr.null;
    }
    reverse(ans.begin(), ans.end());
//    cout << ans << " " << x << " " << count << "\n";
    cout << x << " " << count << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
