import java.util.*;
import java.io.*;

public class Yusuf {
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw = new PrintWriter(System.out);

    public static void main(String[] args) throws IOException {
        int t1 = nextInt();
        int v1 = nextInt();
        int t2 = nextInt();
        int v2 = nextInt();
        if (t2 < 0 && v2 >= 10) {
            pw.print("A storm warning for tomorrow! Be careful and stay home if possible!");
        }else if (t2 < t1){
            pw.print("MCHS warns! Low temperature is expected tomorrow.");
        }else if (v1 < v2) {
            pw.print("MCHS warns! Strong wind is expected tomorrow.");
        }else{
            pw.print("No message");
        }
        pw.close();
    }

    static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    static String next() throws IOException {
        hasNext();
        return st.nextToken();
    }

    static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}