﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 501;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

void solve()
{
    int n; cin >> n;
    int x = 1;
    while (x * (1 << x) < (1 << n))
    {
        ++x;
    }
    vector<string> a;
    for (int i = 0; i < 1 << x; ++i)
    {
        string now = "";
        for (int j = 0; j < x; ++j)
        {
            now += char('0' + ((i & 1 << j) > 0));
        }
        a.push_back(now);
    }
    int mid = (1 << x) / 2;
    vs b;
    int xx = 0;
    while (b.size() * x < (1 << n))
    {
        b.push_back(a[mid + xx]);
        b.push_back(a[mid - xx - 1]);
        ++xx;
    }
    for (auto bb : b)
        cout << bb;
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;// cin >> t;
    while (t--)
        solve();
}