#include <functional>
#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = 2e5 + 1;
const ll mod = 1000000007;

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

struct Event {
	ll x, t;
	bool operator<(Event that) {
		if (x != that.x) return x < that.x;
		return t > that.t;
	}
};

ll n, m, s;

vector<ll> vc;

vector<Event> arr;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> m >> s;
	ll x = m - s;
	vc.resize(m);
	for (ll& i : vc) cin >> i;
	sort(all(vc));
	vc.resize(unique(all(vc)) - vc.begin());
	for (ll i = 0; i < vc.size(); i++) {
		ll i2 = min((ll)vc.size() - 1, i + x - 1);
		if (i2 - i + 1 < x) break;
		if (vc[i2] - vc[i] >= m) continue;
		ll posb = vc[i2] - m + 1;
		ll pose = vc[i] + m - 1;
		posb = max(posb, 1ll);
		pose = min(pose, n);
		pose -= m - 1;
		if (pose >= posb) {
			arr.push_back({ posb, 1 });
			arr.push_back({ pose + 1, -1 });
		}
	}
	sort(all(arr));
	ll ans = 0;
	ll bal = 0;
	for (ll i = 0; i < arr.size(); i++) {
		if (bal > 0) ans += arr[i].x - arr[i - 1].x;
		bal += arr[i].t;
	}
	cout << ans;
	ex();
}