#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>
 
using namespace std;
 
typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;
 
 
void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
 
void formatting () {
    cout << fixed;
    cout.precision(3);
    cout << setprecision(2);
}

void solve();
 
int main () {
    acceleration();
    formatting();
    solve();
}
ll const N = 1e6 + 10, mod = 1e9 + 7;
ll a[3*N];

ll GCD (ll a, ll b){
    if(!b) return a;
    return GCD(b, a % b);
}

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (binpow(n, k / 2) * binpow(n, k / 2)) % mod;
    else return (n * binpow(n, k - 1)) % mod;
}

void solve () {
    ll ans = 0;
    double n, m, l, k;
    cin >> n;
    m = n * 0.01 + 25;
    if(m <= 100){
        cout << 100 << '\n';
        return;
    }
    if(m >= 2000){
        cout << 2000 << '\n';
        return;
    }
    cout << m << '\n';
}
