#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>
 
using namespace std;
 
typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;
 
 
void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
 
void formatting () {
    cout << fixed;
    cout.precision(3);
    cout << setprecision(2);
}

void solve();
 
int main () {
    acceleration();
    solve();
}
ll const N = 1e6 + 10, mod = 1e9 + 7;
ll dp[16][16], dp2[16];
ll k, ans;
vector<int> mas;

ll GCD (ll a, ll b){
    if(!b) return a;
    return GCD(b, a % b);
}

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (binpow(n, k / 2) * binpow(n, k / 2)) % mod;
    else return (n * binpow(n, k - 1)) % mod;
}

void func(int n, int p){
    if(n < 0){
        return;
    }
    if(n == 0){
        int cnt = 0, pr = -1;
        ll curAns = 1;
        mas.push_back(-1);
        
        for(int i = 0; i < mas.size(); i++){
            if(mas[i] != pr){
                if(pr != -1){
                    curAns *= dp2[cnt - 1];
                }
                cnt = 1;
                pr = mas[i];
            } else {
                cnt++;
            }
        }
        mas.pop_back();
        //cout << "\n";
        //cout << curAns << " " << endl;
        ans += curAns;
        return;
    }
    for(int i = p; i <= n; i++){
        mas.push_back(i);
        func(n - i, i);
        mas.pop_back();
    }
}

void solve () {
    int n;
    cin >> n >> k;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < k; j++){
            if(j == 0 || i == 0)
                dp[i][j] = 1;
            else
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            dp2[i] += dp[i][j];
        }
    }
    func(n, 1);
    cout << ans << '\n';
}
