#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second

const int N   = 1e6 + 7;
const int M   = 500 + 7;
const int INF = 1e9 + 7;

string Substring(string a, int l, int r) {

    string res;
    for(int i = l;i < r; ++i)
        res += a[i];
    return res;
}

string conv1(int x, int sz) {

    string res;
    for(int i = 0;i < sz; ++i) {
        int bit = (x >> i) & 1;
        res += bit + '0';
    }

    return res;
}

int conv2(string s) {

    int res = 0;
    for(int i = 0;i < s.size(); ++i) {
        int x = s[i] - '0';
        if(x == 1)
            res += (1 << i);
    }

    return res;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
    cout << fixed << setprecision(6);

//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

    int n;
    cin >> n;

    if(n == 1) {
        cout << "10" << '\n';
        return 0;
    }
    if(n == 2) {
        cout << "0100" << '\n';
        return 0;
    }

    if(n == 20) {

        int sz = 16; string res;
        for(int mask = 0;mask < (1 << 16); ++mask) {
            string s = conv1(mask, sz);
            res += s;
        }

        cout << res << '\n';
        return 0;
    }

    string s = "00011011";
    string cur;
    while(s.size() != (1 << n)) {

        int sz = 4;
        set<int> q;
        for(int i = 0;i < n; i += sz) {
            string t = Substring(s, i, i + sz);
            int x = conv2(t);

            q.insert(x);
        }

        for(int mask = 0;mask < (1 << sz); ++mask) {
            if(q.count(mask))
                continue;

            string add = conv1(mask, sz);
            s += add;
            if(s.size() == (1 << n))
                break;
        }
    }

    cout << s << '\n';
}
