#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <map>
// made by @princebelkovetz //
using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " equals " << x << '\n'; 
const ld pi = acos(-1.0);

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed << setprecision(5);
    int tt; cin >> tt;
    while (tt --> 0) {
        int n; cin >> n;
        vector <int> bad(n), good(n);
        vector <int> ok(n);
        int s1 = 0, s2 = 0;
        for (auto& x : bad) {
            cin >> x;
            s1 += x;
        }
        for (auto& x : good) {
            cin >> x;
            s2 += x;
        }
        //  
        for (int i = 0; i < n; ++i) {
            if (s1 - good[i] > 0) ok[i] = good[i];
            else good[i] = -1;
        }
        int cnt = 0;
        for (auto x : good)
            cnt += (x == -1);
        if (cnt >= 2) {
            cout << "NO\n";
        }
        else if (cnt == 1) {
            int sum = 0;
            for (int i = 0; i < n; ++i) {
                sum += good[i];
            }
            sum++; 
            if (sum > s1) {
                cout << "NO\n";
            }
            else cout << "YES\n";
        }
        else {
            int sum = 0, mx = 0;
            for (auto x : good) {
                sum += x, mx = max(mx, x);
            }
            sum -= mx;
            if (sum > s1) 
                cout << "NO\n";
            else cout << "YES\n";
        }
    }
}