#include <algorithm>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
#include <cstdio>
#include <tuple>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(a) cout << #a << ": " << (a) << '\n'

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 2e5 + 100;

int n, k;
unsigned long long ans = 0;
unsigned long long step[20], razl[20][20];

void rec(int x, int j, int cnt, int uniq){
    if (x == 0){
        razl[cnt][uniq]++;
        return;
    }
    for (int i = j; i <= x; i++){
        int k = 0;
        if (i != j)
            k++;
        rec(x - i, i, cnt + 1, uniq + k);
    }
}
int main() {
    fast();
    cin >> n >> k;
    step[0] = 1;
    for (int i = 1; i <= 15; i++)
        step[i] = step[i - 1] * k;
    rec(n, 1, 0, 1);
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= n; j++){
            ans += step[j] * razl[i][j];
        }
    }
    cout << ans << '\n';
    return 0;
}
