#include <algorithm>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
#include <cstdio>
#include <tuple>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(a) cout << #a << ": " << (a) << '\n'

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 2e5 + 100;

int main() {
    fast();
    int t1, v1, t2, v2;
    cin >> t1 >> v1 >> t2 >> v2;
    if (t2 < 0 && v2 >= 10)
        cout << "A storm warning for tomorrow! Be careful and stay home if possible!\n";
    if (t1 > t2)
        cout << "MCHS warns! Low temperature is expected tomorrow.\n";
    else if (v1 < v2)
        cout << "MCHS warns! Strong wind is expected tomorrow.\n";
    else
        cout << "No message\n";
    return 0;
}
