#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <assert.h>
#include <string>
#include <deque>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;

ll l, r;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	return a * bin_pow(a, n - 1);
}

ll get(int el, int x) {
	string s = to_string(el);
	ll len = s.size();
	vector<bool>t(len, false);
	t[s.size() - 1] = true;
	for (int i = s.size() - 1; i > 0; i--) {
		if (s[i - 1] <= s[i])
			t[i - 1] = true;
	}
	ll dop = 1;
	vector<ll>dp(len - x + 1);
	dp[0] = s[0] - '0';
	dop = s[0] - '0';
	for (int i = 1; i < dp.size(); i++) {
		dp[i] = s[i] - '0';
		if (t[i])
			dp[i]++;
		dp[i] += 10 * dop;
		dop *= s[0] - '0' + 1;
		dp[i] += dp[i - 1];
	}
	return dp.back();
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	int t; cin >> t;
	for (int _ = 0; _ < t; _++) {
		cin >> l >> r;
		int x = 1;
		for (x; x <= 18; x++)
			if (get(r, x) == get(l - 1, x))
				break;
		x--;
		cout << x << ' ';
		cout << get(r, x) - get(l - 1, x) << '\n';
	}
	return 0;
}