#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

const int N = 19;

int p[N];

int Fans = 0;
int Sans = 0;
int sz;
string L, R;

void relax(int f, int s) {
    if (Fans == f) {
        Sans += s;
    } else if (f > Fans) {
        Fans = f;
        Sans = s;
    }
}

void relax_pref(string s) {
    // cerr << "pref " << s << endl;
    int len = sz - s.size();
    reverse(s.begin(), s.end());
    while (!s.empty() && s.back() == '0') {
        s.pop_back();
    }
    reverse(s.begin(), s.end());
    int cur_cnt = 0;
    int max_cnt = -1;
    int prev = -1;
    for (auto X : s) {
        int d = X - '0';
        if (d == prev) {
            cur_cnt++;
        } else {
            cur_cnt = 1;
        }
        max_cnt = max(max_cnt, cur_cnt);
        prev = d;
    }
    int val = max(max_cnt, len + cur_cnt);
    if (val == max_cnt) {
        relax(val, p[len]);
    } else {
        relax(val, 1);
    }
}

void solve(string &s) {
    // cerr << "hr " << s << endl;
    int okl = 0;
    int okr = 0;
    int bl = 0;
    int br = 0;
    {
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == L[i]) {
                //
            } else {
                okl = (s[i] > L[i]);
                bl = (s[i] < L[i]);
                break;
            }
        }
    }
    {
       for (int i = 0; i < s.size(); i++) {
            if (s[i] == R[i]) {
                //
            } else {
                okr = (s[i] < R[i]);
                br = (s[i] > R[i]);
                break;
            }
        }
    }
    if (bl || br) return;
    if ((okl && okr) || ((int)s.size() == sz)) {
        relax_pref(s);
        return;
    }
    // int i = s.size();
    for (char c = 0; c < 10; c++) {
        s.push_back(c + '0');
        solve(s);
        s.pop_back();
    }
}

void solve() {
    p[0] = 1;
    for (int i = 1; i < N; i++) {
        p[i] = 10 * p[i - 1];
    }
    Fans = 0;
    Sans = 0;
    cin >> L >> R;
    while (L.size() < R.size()) {
        L.insert(L.begin(), 0);
    }
    sz = (int)R.size();
    string tmp;
    solve(tmp);
    cout << Fans << ' ' << Sans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
