#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    vector<int> a(m);
    for (auto &t : a) {
        cin >> t;
    }
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    auto can = [&](int i) {
        return upper_bound(a.begin(), a.end(), i + m) - lower_bound(a.begin(), a.end(), i) + s >= m;
    };
    int ans = 0;
    int prev = 0;
    for (auto cur : a) {
        int l = prev;
        int r = cur;
        if (can(r)) {
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (can(mid)) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            r = max(r, 1);
            r = min(r, n - m);
            if (prev < r && r <= cur) {
                ans += (cur - r + 1);
            }
        }
        prev = cur;
    }
    cout << ans << '\n';
}
