#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <deque>
#include <iomanip>
#include <queue>

using namespace std;

vector<vector<int>> all;

void gen(int n, vector<int> &x) {
    if (n == 0) {
        all.push_back(x);
        return;
    }
    int start = 1;
    if (x.size()) {
        start = x.back();
    }
    for(int i = start; i <= n; ++i) {
        x.push_back(i);
        gen(n - i, x);
        x.pop_back();
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    vector <int> a(m);
    for (int i = 0; i < m; ++i) cin >> a[i];
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    vector <pair <int, int>> event;
    for (int i = 0; i < a.size(); ++i) {
        event.emplace_back(max(a[i] - m + 1, 1), 0);
        event.emplace_back(a[i] + 1, 1);
    }
    sort(event.begin(), event.end());
    while (!event.empty() && event.back().first > n - m + 1) event.pop_back();
    long long ans = 0;
    int cur = 0;
    for (int i = 0; i < event.size(); ++i) {
        if (event[i].second == 0) ++cur;
        else --cur;
        if (i == (int)event.size() - 1) {
            if (m - cur <= s) {
                ans += (n - m + 1) - event[i].first + 1;
            }
        }
        else if (event[i + 1].first != event[i].first) {
            if (m - cur <= s) ans += event[i + 1].first - event[i].first;
        }
    }
    cout << ans;
}
