#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <deque>
#include <functional>
#include <queue>
#include <cmath>
#include <array>
/// #include <bits/stdc++.h>
 
#define int long long
/// #define endl '\n'

using namespace std;

struct Vector
{
    int x, y;
    
    Vector(int x1 = 0, int y1 = 0) {
        x = x1; y = y1;
    }
    
    Vector(const Vector &v1, const Vector &v2) {
        x = v2.x - v1.x; y = v2.y - v1.y;
    }
    
    int sqlen() {
        return x * x + y * y;
    }
};


int cross(Vector v1, Vector v2) {
    return v1.x * v2.y - v2.x * v1.y;
}

istream &operator>>(istream &in, Vector &v) {
    in >> v.x >> v.y;
    return in;
}

const int MAXN = 500;
Vector arr[MAXN];
Vector arr1[MAXN];
int used[MAXN][MAXN];

bool cmp(Vector v1, Vector v2) {
    if (cross(v1, v2) != 0) {
        return cross(v1, v2) < 0;
    }
    return v1.sqlen() < v2.sqlen();
}

bool check(Vector a, Vector b, Vector c, Vector d) {
    return cross(Vector(a, b), Vector(a, c)) * cross(Vector(a, b), Vector(a, d)) < 0;
}

bool is_inter(Vector a, Vector b, Vector c, Vector d) {
    return check(a, b, c, d) && check(c, d, a, b);
}

signed main () {
    int n;
    cin >> n;
    Vector minp = {100000, 0};
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        if (arr[i].x < minp.x) {
            minp = arr[i];
        } else if (arr[i].x == minp.x && arr[i].y < minp.y) {
            minp = arr[i];
        }
        arr1[i] = arr[i];
    }
    /// cerr << is_inter(arr1[0], arr1[5], arr1[1], arr1[3]) << endl;
    for (int i = 0; i < n; ++i) {
        arr[i] = Vector(minp, arr[i]);
    }
    sort(arr, arr + n, cmp);
    vector<Vector> st;
    arr[n] = arr[0];
    st.push_back(arr[0]);
    int sz = 1;
    for (int i = 1; i <= n; ++i) {
        while (sz >= 2 && cross(Vector(st[sz - 2], st[sz - 1]), Vector(st[sz - 1], arr[i])) >= 0) {
            st.pop_back();
            sz--;
        }
        st.push_back(arr[i]);
        sz++;
    }
    st.pop_back();
    sz--;
    int k = st.size();
    /// cerr << k << endl;
    int edg = 3 * n - k - 3;
    if (edg % 2 == 1) {
        cout << 1 << endl;
    } else {
        cout << 2 << endl;
    }
    vector<array<Vector, 2>> all;
    int lsti = 0, lstj = 0;
    for (int num = 1; num <= edg; ++num) {
        if (num % 2 == edg % 2) {
            bool f = true;
            for (int i = lsti; i < n && f; ++i) {
                for (int j = 0; j < i && f; ++j) {
                    if (i == lsti) {
                        j = max(j, lstj);
                    }
                    if (used[i][j]) {
                        continue;
                    }
                    bool f1 = false;
                    for (auto elem : all) {
                        if (is_inter(elem[0], elem[1], arr1[i], arr1[j])) {
                            f1 = true;
                            break;
                        }
                    }
                    if (!f1) {
                        f = false;
                        all.push_back({arr1[i], arr1[j]});
                        lsti = i; lstj = j;
                        used[i][j] = used[j][i] = 1;
                        cout << i + 1 << " " << j + 1 << endl;
                    }
                }
            }
        } else {
            int i, j;
            cin >> i >> j;
            if (i == 0) {
                return 0;
            }
            i--; j--;
            used[i][j] = used[j][i] = 1;
            all.push_back({arr1[i], arr1[j]});
        }
    }
    int i, j;
    cin >> i >> j;
    /// assert(i == 0);
    return 0;
}

/**
 6
 0 0
 -1 4
 4 0
 2 3
 5 4
 2 7
 */
