//
// Created by omega_alpha on 02.12.2020.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FF first
#define SS second

using ll = long long;
using ld = long double;

#define int ll

template<typename T>
using vec = std::vector<T>;

template<typename T>
using uset = std::unordered_set<T>;

template<typename T1, typename T2>
using umap = std::unordered_map<T1, T2>;

constexpr ll INFL = 1000000000000000069;
constexpr int INFI = 1000000069;
const ld PI = acos(-1);

#ifdef LOCAL
std::mt19937 rnd(69);
#else
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
#endif

vec<pair<int, int>> DD = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

#ifdef LOCAL
#else
#endif

void run() {
  int n;
  cin >> n;
  set<pair<int, int>> st;
  vec<int> a(n), b(n);
  vec<tuple<int, int, int>> ab(n);
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    ab[i] = {b[i], a[i], i};
  }
  sort(RALL(ab));
  for (int i = 0; i < n; i++) {
    st.insert({a[i], i});
  }
  for (auto [bi, ai, i] : ab) {
    pair<int, int> ff {-1, -1};
    while (bi > 0 && st.size()) {
      auto tt = *st.begin();
      st.erase(st.begin());
      if (tt.second == i) {
        ff = tt;
        continue;
      }
      int dt = min(bi, tt.first);
      bi -= dt;
      tt.first -= dt;
      if (tt.first > 0) {
        st.insert(tt);
      }
    }
    if (ff.first != -1) {
      st.insert(ff);
    }
  }
  if (st.size() <= 1) {
    cout << "YES\n";
  } else {
    cout << "NO\n";
  }
}

signed main() {
#ifdef LOCAL
  std::freopen("input.txt", "r", stdin);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  int t = 1;
   cin >> t;
  while (t--) {
    run();
  }
  return 0;
}


