#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ll> vll;
typedef complex<double> cd;

const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007, mod2 = 998'244'353;
const ll llinf = 1e18;
const ld pi = 3.141592653589793238462643383279502884197169399375105820974944592307816406286208998628034825;

//#define forn(i, n) for (int i = 0; i < (int)n; ++i)
//#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)
#define firn(i, n) for (int (i) = 1; (i) != (n); (i)++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())

template<typename T> bool uin(T &a, T b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, T b) { if (b > a) { a = b; return true; } return false; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while (begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));
mt19937_64 rnd_64(time(nullptr));

void dfs(int v, vvi &g, int c, vi &vis, vi &col)
{
    col[v] = c;
    vis[v] = 1;
    for (auto u : g[v]) if (vis[u] == 0)
    {
        dfs(u, g, 1 ^ c, vis, col);
    }
}

void add(vector<string> &ans, int x1, int y1, int x2, int y2)
{
    int c = x1 % 3 * 3 + y1 % 3;
    ans[x1][y1] = '0' + c;
    ans[x1][y2] = '0' + c;
    ans[x2][y1] = '0' + c;
    ans[x2][y2] = '0' + c;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (int i = 0; i < n; ++i)
    {
    	cin >> s[i];
    }
    auto free = [&](int x, int y)
    {
    	return 0 <= x && x < n && 0 <= y && y < m && s[x][y] == '.';
    };
    auto iscapc = [&](char c)
    {
    	return 'A' <= c && c <= 'Z';
    };
    vector<string> ans(n, string(m, '.'));
    int res = 0;
    int kek = 0;
    vector<vector<int> > a(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
    {
    	for (int j = 0; j + 1 < m; j++)
    	{
    		if (s[i][j] == s[i][j + 1] && !free(i, j))
            {
                a[i][j] = kek;
                a[i][j + 1] = kek;
                kek++;
            }
    	}
    }
    for (int i = 0; i + 1 < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (s[i][j] == s[i + 1][j] && !free(i, j))
            {
                a[i][j] = kek;
                a[i + 1][j] = kek;
                kek++;
            }
        }
    }
    vector<vector<int> > g(kek);
    vector<vector<vector<int> > > zones(n, vector<vector<int> >(m));
    vector<int> blocked(kek);
    for (int i = 0; i < n; i++)
    {
    	for (int j = 0; j + 1 < m; j++)
    	{
    		if (s[i][j] == s[i][j + 1] && !free(i, j))
            {
                if (iscapc(s[i][j]))
                {
                    if (free(i + 1, j) && free(i + 1, j + 1))
                        zones[i + 1][j].push_back(a[i][j]), zones[i + 1][j + 1].push_back(a[i][j]);
                    else
                        blocked[a[i][j]] = 1;
                }
                else
                {
                    if (free(i - 1, j) && free(i - 1, j + 1))
                        zones[i - 1][j].push_back(a[i][j]), zones[i - 1][j + 1].push_back(a[i][j]);
                    else
                        blocked[a[i][j]] = 1;
                }
            }
    	}
    }
    for (int i = 0; i + 1 < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (s[i][j] == s[i + 1][j] && !free(i, j))
            {
                if (iscapc(s[i][j]))
                {
                    if (free(i, j + 1) && free(i + 1, j + 1))
                        zones[i][j + 1].push_back(a[i][j]), zones[i + 1][j + 1].push_back(a[i][j]);
                    else
                        blocked[a[i][j]] = 1;
                }
                else
                {
                    if (free(i, j - 1) && free(i + 1, j - 1))
                        zones[i][j - 1].push_back(a[i][j]), zones[i + 1][j - 1].push_back(a[i][j]);
                    else
                        blocked[a[i][j]] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            assert(zones[i][j].size() <= 2);
            if (zones[i][j].size() == 2)
            {
                g[zones[i][j][0]].push_back(zones[i][j][1]);
                g[zones[i][j][1]].push_back(zones[i][j][0]);
            }
        }
    }
    vector<int> vis(kek);
    vector<int> color(kek);
    int d = 0;
    for (int i = 0; i < kek; i++)
    {
        //cout << blocked[i] << " " << g[i].size() << endl;
        if (!blocked[i] && g[i].size() <= 1 && vis[i] == 0)
        {
            dfs(i, g, 1, vis, color);
        }
    }
    for (int i = 0; i < kek; i++)
    {
        //cout << blocked[i] << " " << g[i].size() << endl;
        if (!blocked[i] && g[i].size() <= 2 && vis[i] == 0)
        {
            dfs(i, g, 1, vis, color);
        }
    }
    d = accumulate(all(color), 0);
    cout << d << "\n";
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j + 1 < m; j++)
        {
            if (s[i][j] == s[i][j + 1] && a[i][j] >= 0 && a[i][j + 1] >= 0 && color[a[i][j]])
            {
                if (iscapc(s[i][j]))
                    add(ans, i, j, i + 1, j + 1);
                else
                    add(ans, i - 1, j, i, j + 1);
            }
            if (s[i][j] == s[i][j + 1] && a[i][j] >= 0 && a[i][j + 1] >= 0 && !color[a[i][j]])
            {
                add(ans, i, j, i, j + 1);
            }
        }
    }
    for (int i = 0; i + 1 < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (s[i][j] == s[i + 1][j] && a[i][j] >= 0 && a[i + 1][j] >= 0 && color[a[i][j]])
            {
                if (iscapc(s[i][j]))
                    add(ans, i, j, i + 1, j + 1);
                else
                    add(ans, i, j - 1, i + 1, j);
            }
            if (s[i][j] == s[i + 1][j] && a[i][j] >= 0 && a[i + 1][j] >= 0 && !color[a[i][j]])
            {
                add(ans, i, j, i + 1, j);
            }
        }
    }
    for (int i = 0;  i < n; i++) cout << ans[i] << "\n";
}
