#include <iostream>
#include <string>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

deque <string> ord;

string convert(ll n, ll c)
{
    string w = "";
    while (n > 0)
    {
        w.push_back((char)('0' + (n % 2)));
        n /= 2;
    }
    while (w.size() < c) w.push_back('0');
    reverse(w.begin(), w.end());
    return w;
}

int main()
{
    ll n;
    cin >> n;
    ll m = 0;
    while (m + (1 << m) <= n) m++;
    m--;
    for (ll i = 0; i <= (1LL << (1LL << m)) - 1; i++) ord.push_back(convert(i, 1 << m));
    //for (string s : ord) cout << ": " << s << endl;
    ll qq = (1LL << n) / (1LL << m) / (1LL << (1LL << m));
    for (ll i = 0; i < qq; i++)
    {
        for (string s : ord) cout << s;
        ord.push_back(ord.front());
        ord.pop_front();
    }
    return 0;
}
