#include <iostream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;

bool comp(pair<ll, ll> & a, pair<ll, ll>& b) {
    return a.first > b.first;
}

int main() {
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i ++) {
        ll n;
        cin >> n;
        ll m = 0;
        vector<pair<ll, ll>> gods(n);
        for (ll i = 0; i < n; i ++) cin >> gods[i].first;
        for (ll i = 0; i < n; i ++) {
                cin >> gods[i].second;
                m = max(m, gods[i].second);
        }
        sort(gods.begin(), gods.end(), comp);
        ll add = 0;
        bool ans = true;
        ll j = 1;
        ll count = 0;
        for (ll i = 0; i < n; i ++) {
            if (i == j) {
                j ++;
            }
            ll total = gods[i].second;
            if (total == m && count == 0) {
                count ++;
                add += gods[i].first;
                continue;
            }
            while (j < n && total > 0) {
                ll d = min(total, gods[j].first);
                total -= d;
                gods[j].first -= d;
                if (gods[j].first == 0)
                    j ++;
            }
            if (total > add) {
                ans = false;
                break;
            }
            add -= total;
            add += gods[i].first;

        }
        if (ans)
            cout << "YES\n";
        else
            cout << "NO\n";
    }
}
