#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <unordered_set>
#include <tuple>
#include <queue>
#include <set>
#include <cstring>
#include <functional>
#include <random>
#include <chrono>
#include <cassert>
#include <iomanip>
// #include <ext/pb_ds/assoc_container.hpp>

#define ar array
#define all(arr) (arr).begin(), (arr).end()
#define range(i, n) for (int i=0; i < (n); ++i)
#define rall(arr) (arr).rbegin(), (arr).rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

// using namespace __gnu_pbds;
/*
typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

const ll INF = 1e18;
const int INFi = 2e9;
const int maxN = 2e6 + 1;
const int md2 = 998244353;
const int md3 = 1e9 + 7;

double getTime() { return clock() / (double) CLOCKS_PER_SEC; }

vector<int> g[maxN], g2[maxN];

const int mx = 1e3 + 5;
char a[mx][mx];
bool has[mx][mx];
vector<int> can[mx][mx];
int tp[maxN];
int b[mx][mx];
bool bad[maxN];
bool hu[maxN];

vector<int> di = {0, 0, 1, -1};
vector<int> dj = {1, -1, 0, 0};

int dp[maxN][2];
bool used[maxN];
bool have[maxN];
int answ[mx][mx];
int col[maxN];
vector<int> mex[maxN];
int ans = 0;

void dfs(int v, int p) {
    used[v] = true;
    have[v] = true;
    for (auto &u : g[v]) {
        if (u == p) continue;
        if (!used[u]) {
            dfs(u, v);
        }
        if (have[u]) have[v] = false;
    }
    if (have[v]) {
        ans++;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    range(i, n) {
        range(j, m) {
            cin >> a[i + 1][j + 1];
            if (a[i + 1][j + 1] != '.') has[i + 1][j + 1] = true;
        }
    }
    int cnt = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (!has[i][j]) continue;
            if (b[i][j]) continue;
            range(w, 4) {
                int i2 = i + di[w];
                int j2 = j + dj[w];
                if (a[i2][j2] == a[i][j]) {
                    b[i][j] = b[i2][j2] = cnt;
                    if (('a' <= a[i][j] && a[i][j] <= 'z')) {
                        if (i == i2) {
                            tp[cnt] = 3;
                        } else {
                            tp[cnt] = 1;
                        }
                    } else {
                        if (i == i2) {
                            tp[cnt] = 2;
                        } else {
                            tp[cnt] = 0;
                        }
                    }
                    cnt++;
                    break;
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (!b[i][j]) continue;
            int i2 = i + di[tp[b[i][j]]];
            int j2 = j + dj[tp[b[i][j]]];
            can[i2][j2].push_back(b[i][j]);
        }
    }
    range(i, n + 2) {
        range(j, m + 2) {
            bool bb = false;
            if (i == 0 || i == n + 1 || j == 0 || j == m + 1) bb = true;
            if (has[i][j]) bb = true;
            if (!bb) continue;
            for (auto &x : can[i][j]) {
                bad[x] = true;
            }
        }
    }
    range(i, n + 2) {
        range(j, m + 2) {
            bool bb = false;
            if (i == 0 || i == n + 1 || j == 0 || j == m + 1) bb = true;
            if (has[i][j]) bb = true;
            if (bb) continue;
            for (auto &x : can[i][j]) {
                if (bad[x]) continue;
                for (auto &y : can[i][j]) {
                    if (bad[y] || y == x) continue;
                    g[x].push_back(y);
                }
            }
        }
    }
    for (int i = 1; i < cnt; ++i) {
        if (bad[i]) continue;
        sort(all(g[i]));
        g[i].resize(unique(all(g[i])) - g[i].begin());
    }
    ans = 0;
    for (int i = 1; i < cnt; ++i) {
        if (used[i] || bad[i]) continue;
        dfs(i, -1);
    }
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = 0; j <= m + 1; ++j) {
            answ[i][j] = -1;
        }
    }
    memset(col, -1, sizeof(col));
    cout << ans << '\n';
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (!has[i][j]) continue;
            int x = b[i][j];
            answ[i][j] = x;
            if (bad[x] || !have[x]) continue;
            int i2 = i + di[tp[x]];
            int j2 = j + dj[tp[x]];
            answ[i2][j2] = x;
        }
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            range(w, 4) {
                int i2 = i + di[w];
                int j2 = j + dj[w];
                if (answ[i][j] == -1 || answ[i2][j2] == -1) continue;
                mex[answ[i][j]].push_back(answ[i2][j2]);
            }
        }
    }
    for(int x = 1; x < cnt; ++x) {
        vector<int> cols;
        for(auto &y : mex[x]) {
            cols.push_back(col[y]);
        }
        sort(all(cols));
        cols.resize(unique(all(cols)) - cols.begin());
        for(int i = 0; i < (int)cols.size(); ++i) {
            if (i + 1 == cols.size() || cols[i] + 1 != cols[i + 1]) {
                col[x] = cols[i] + 1;
                break;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (answ[i][j] == -1) {
                cout << '.';
            } else {
                cout << col[answ[i][j]];
            }
        }
        cout << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    // cout << setprecision(15) << fixed;
    int tests = 1;
    // cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}