//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("fma,avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

mt19937 rnd(6547389847627);

typedef long long ll;

#define int unsigned long long
#define ld double
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define sqr(a) (a) * (a)
#define debug(x) cout << #x << ": " << x << '\n'

template<class t, class u>
void amax(t &a, u b) { if (a < b) a = b; }

template<class t, class u>
void amin(t &a, u b) { if (b < a) a = b; }

template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

#define one(x) memset(x, -1, sizeof(x))
#define zero(x) memset(x, 0, sizeof(x))
#define MAXC 40
int C[MAXC][MAXC];

void precalc() {
    for (int i = 0; i < MAXC; i++) {
        for (int j = 0; j <MAXC;j++){
            C[i][j] = 1;
        }
    }
    C[0][0] = 1;
    C[1][0] = C[1][1] = 1;
    for (int i = 2; i < 40; ++i) {
        C[i][0] = 1;
        C[i][i] = i;
        C[i][1] = i;
        for (int j = 2; j < i; ++j) {
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
        }
    }
}

vector<int> cnt;
int k;
int ans = 0;

void gen(int ind, int c) {
    if (ind == 1) {

        cnt[ind] = c;
        int cur = 1;
        for (int i = 1; i < cnt.size(); ++i) {
            //cout << cnt[i]<<" "<<cur<<" ";
            cur *= C[cnt[i] + k - 1][k - 1];
        }
        //cout << cur<<"\n";
        ans += cur;
        return;
    }
    for (int i = 0; i * ind <= c; ++i) {
        cnt[ind] = i;
        gen(ind - 1, c - i * ind);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    precalc();
    int n;
    cin >> n >> k;
    cnt.resize(n + 1);
    gen(n, n);
    cout << ans;
    return 0;
}
