#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
//#define endl '\n'
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const ldb EPS = 1e-8;
const ldb PI = acosl(-1.);
const ll MOD = 998244353;

pii a[300];
pii ar[300];

ll vec(pii &a, pii &b, pii &c) {
    pii b0 = {b.first - a.first, b.second - a.second};
    pii c0 = {c.first - a.first, c.second - a.second};
    return (ll)b0.first * c0.second - (ll)b0.second * c0.first;
}

bool cmp(pii &x, pii &y) {
    return vec(ar[0], x, y) > 0;
}

vector<pii> edges;

signed main() {
    fastream;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        ar[i] = a[i];
        if (ar[i].second < ar[0].second || (ar[i].second == ar[0].second && ar[i].first < ar[0].first)) {
            swap(ar[0], ar[i]);
        }
    }
    sort(ar + 1, ar + n, cmp);
    vector<pii> st;
    st.emplace_back(ar[0]);
    for (int i = 1; i < n; i++) {
        while (st.size() >= 2 && vec(st.back(), st[st.size() - 2], ar[i]) > 0) {
            st.pop_back();
        }
        st.emplace_back(ar[i]);
    }
    if ((3 * n - st.size() - 3) & 1) {
        cout << 1 << endl;
    } else {
        cout << 2 << endl;
        int u, v;
        cin >> u >> v;
        if (u == 0 && v == 0) {
            return 0;
        }
        u--, v--;
        if (u > v) {
            swap(u, v);
        }
        edges.emplace_back(u, v);
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            bool good = 1;
            for (auto &k : edges) {
                if (k.first == i && k.second == j) {
                    good = 0;
                }
                if (vec(a[k.first], a[k.second], a[i]) * vec(a[k.first], a[k.second], a[j]) < 0 && vec(a[i], a[j], a[k.first]) * vec(a[i], a[j], a[k.second]) < 0){
                    good = 0;
                }
            }
            if (good) {
                cout << i + 1 << ' ' << j + 1 << endl;
                edges.emplace_back(i, j);
                int u, v;
                cin >> u >> v;
                if (u == 0 && v == 0) {
                    return 0;
                }
                u--, v--;
                if (u > v) {
                    swap(u, v);
                }
                edges.emplace_back(u, v);
            }
        }
    }
}
