#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <tuple>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

using namespace std;

__int128 ans = 0;

int k;

void gen(__int128 n, __int128 last, vector<__int128>& a) {
    if (!n) {
        __int128 last = 0;
        __int128 cnt = 0;
        __int128 x = 1;
        for (auto& i : a) {
            if (i == last) {
                ++cnt;
            }
            else {
                for (__int128 tmp = 0; tmp < k - 1; ++tmp) {
                    x *= (cnt + 1);
                }
                last = i;
                cnt = 1;
            }
        }
        for (__int128 tmp = 0; tmp < k - 1; ++tmp) {
            x *= (cnt + 1);
        }
        ans += x;
        return;
    }
    for (__int128 i = last; n - i >= i; i++) {
        if (!i) {
            continue;
        }
        a.push_back(i);
        gen(n - i, i, a);
        a.pop_back();
    }
    a.push_back(n);
    gen(0, n, a);
    a.pop_back();
}

void solve() {
    int n;
    cin >> n >> k;
    vector<__int128> a;
    gen(n, 0, a);
    vector<int> res;
    while (ans > 0) {
        int x = (ans % 10);
        res.push_back(x);
        ans /= 10;
    }
    for (__int128 i = res.size() - 1; i >= 0; i--) {
        cout << res[i];
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    __int128 t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
