#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Point {
    ld x, y;
};

istream& operator >> (istream& f, Point& a) {
    f >> a.x >> a.y;
    return f;
}

ostream& operator << (ostream& f, Point& a) {
    f << a.x << ' ' << a.y;
    return f;
}

ostream& operator << (ostream& f, vector<ll>& a) {
    for (auto i : a) {
        f << i << ' ';
    }
    return f;
}

ostream& operator << (ostream& f, vector<int>& a) {
    for (auto i : a) {
        f << i << ' ';
    }
    return f;
}

ll min(ll a, int b) {
    return min(a, ll(b));
}

ll min(int a, ll b) {
    return min(ll(a),(b));
}



struct tr {
    int cost, i, j;
};

bool operator < (tr a, tr b) {
    return a.cost < b.cost;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;
        vector<ll> a(n), b(n);
        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            sum += a[i];
        }
        ll ma = -1;
        int ind = 0;
        for (int i = 0; i < n; ++i){
            cin >> b[i];
            if ((b[i] > ma) || (b[i] == ma && a[i] > a[ind])) {
                ma = b[i];
                ind = i;
            }
        }
        bool fl = true;
        for (int i = 0; i < n; ++i) {
            if (i == ind) {
                continue;
            }
            if (b[i] > sum - a[i]) {
                fl = false;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (i == ind) {
                continue;
            }
            if (sum < b[i]) {
                fl = false;
            }
            sum -= b[i];
        }

        if (!fl) {
            cout << "NO";
        } else {
            cout << "YES";
        }
        cout << "\n";
    }
}