#include <bits/stdc++.h>
#define pb push_back
#define sz(a) (int)a.size()
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;

int n, a[N], b[N], order[N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    for (int i = 1; i <= n; ++i) cin >> b[i];
    iota(order + 1, order + n + 1, 1);
    sort(order + 1, order + n + 1, [&](int i, int j) {
         return make_pair(b[i], a[i]) < make_pair(b[j], a[j]);
    });
    ll A = accumulate(a + 1, a + n + 1, 0ll), B = accumulate(b + 1, b + n + 1, 0ll);
    if (B - b[order[n]] > A) {
        cout << "NO\n";
        return;
    }
    for (int i = 1; i < n; ++i) {
        int j = order[i];
        if (b[j] > A - a[j]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
