#include <bits/stdc++.h>
using namespace std;

#ifdef _LOCAL_JUDGE
template<class H> void _dbg(const char* s, H h) { cerr << s << " = " << h << endl; }
template<class H, class ...T> void _dbg(const char* s, H h, T... t) {
    while (*s != ',') { cerr << *s++; } cerr << " = " << h << ","; _dbg(s + 1, t...);
}
#define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
#else
#define dbg(...)
#endif

template<typename T>
T gcd(T a, T b) {
    return b == 0 ? a : gcd(b, a % b);
}

#define ers erase
#define ins insert
#define pb push_back
#define sqr(x) ((x) * (x))
#define pw2(x) (1 << (x))
#define str(x) to_string((x))
#define sz(x) ((int32_t) (x).size())
#define all(x) (x).begin(), (x).end()
#define lcm(a, b) ((a) / gcd((a), (b)) * (b))
#define optimize { cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0); }

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;


void solve() {
    int n;
    cin >> n;

    vector<pll> a(n);

    ll sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
        sum += a[i].second;
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }

    sort(all(a));

    ll used = 0;
    for (int i = 0; i < n - 1; i++) {
        ll x = min(a[i].second, used);
        a[i].second -= x;

        if (sum - a[i].first - used - a[i].second < 0) {
            cout << "NO";
            return;
        }

        used += a[i].first;
    }

    cout << "YES";
}

int32_t main() {
    optimize;

#ifdef _LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif


    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}