// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

#include <iostream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <chrono>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <math.h>
#include <limits.h>
#include <cstdio>
#include <stdio.h>
#include <queue>
#include <bitset>
#include <cstdlib>
#include <deque>
#include <cassert>
#include <stack>
using namespace std;
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;

// typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define mp make_pair
#define f first
#define se second
#define pb push_back
#define ppb pop_back
#define emb emplace_back
#define ll long long
#define ull unsigned long long
#define cntbit(x) __builtin_popcount(x)
#define endl '\n'
#define uset unordered_set
#define umap unordered_map
#define pii pair<int, int>
#define ld long double
#define pll pair<long long, long long>

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T> inline T range(T l, T r) {
    return uniform_int_distribution<T>(l, r)(rng);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

#define int long long

const ll INF = 2e18;
const int mod = 1e9 + 7;
const int inf = 0x3f3f3f3f;
const int N = 2e6 + 15;
const int p = 41;
int n;
uset <int> d;
int s[N], st[N];
string ans;
int res;

inline int add(int a, int b) {
	a += b;
	if(a >= mod)
		return a - mod;
	if(a < 0)
		return a + mod;
	return a;
}

inline int mul(int a, int b) {
	return 1LL * a * b % mod;
}

inline int get_hash(int l, int r) {
	int h = 0;
	for(int i = l; i <= r; ++i)
		h = add(h, mul(s[i], st[i-l]));
	return h;
}

void rec(int l, int r) {
	if(l == r)
		return void(d.insert(get_hash(l, r)));
	int mid = l + r >> 1;
	d.insert(get_hash(l, mid));
	d.insert(get_hash(mid+1, r));
	rec(l, mid);
	rec(mid + 1, r);
}

bool solve() {
	for(int i = 0; i < (1 << n); ++i)
		s[i] = range(0, 1);
	d.clear();
	rec(0, (1 << n) - 1);
	int need = 0;
	for(int i = 0; i < n; ++i)
		need += min((1 << i), (1 << (n - i)));
	if(d.size() > res) {
		ans.clear();
		for(int i = 0; i < (1 << n); ++i)
			ans += char('0' + s[i]);
		res = d.size();
	}            
}

main() {                              
	st[0] = 1;
	for(int i = 1; i < N; ++i)
		st[i] = mul(st[i-1], p);
	cin >> n;
		res = 0;
		for(int iter = 0; iter < 100; ++iter)
			solve();
//		cout << n << ' ' << res << ' ' << ans << endl;
	cout << ans << endl;
	return 0;
}
