#include <bits/stdc++.h>
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define all(x) begin(x), end(x)
#define OK cout << "OK" << endl
#define print(x) cout << x << endl
#pragma GCC optimize ("O3")
//#pragma GCC target ("avx,avx2,sse,sse2")
//#pragma GCC optimize ("O2")
//#define endl '\n'
#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, k, res;
int a[20], factorial[20];

int cnk(int n_, int k_)
{
    return factorial[n_] / factorial[k_] / factorial[n_ - k_];
}

void calculate()
{
    int ans = 1;
    for(int i = 1; i <= n; i++)
    {
        if (a[i] == 0) continue;
        if (a[i] == 1)
        {
            ans *= k;
            continue;
        }
        int tmp_ans = 0;
        for(int j = max(0ll, k - a[i]); j < k; j++)
        {
            //cout << k - j - 1 << " " << a[i] - 1 << "  " << k - j << " " << k << endl;
            tmp_ans += cnk(a[i] - 1, k - j - 1) * cnk(k, k - j);
        }
        ans *= tmp_ans;
    }
    res += ans;
}

void build_array(int n, int cur = 1)
{
    if (n == 0)
    {
        calculate();
        return;
    }
    if (cur > n) return;
    for(int i = 0; i <= n / cur; i++)
    {
        a[cur] = i;
        build_array(n - i * cur, cur + 1);
        a[cur] = 0;
    }
}

main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    factorial[0] = 1;
    for(int i = 1; i <= 15; i++) factorial[i] = factorial[i - 1] * i;
    cin >> n >> k;
    build_array(n);
    cout << res << endl;
}
