#include <cstdio>
#include <cstring>

const int N = 18;
const int A = 10;

int t;
char l[N + 1], r[N + 1];
long long pw[N + 1];

void pr(char *s, int n)
{
    for (int i = N - 1; i >= N - n; --i) s[i] = s[i - N + n];
    for (int i = 0; i < N - n; ++i) s[i] = '0';
}

void sub1(char *s)
{
    int i;
    for (i = N - 1; s[i] == '0'; --i) s[i] = '0' + A - 1;
    --s[i];
}

long long get(char *s, const int k)
{
    long long ans = 0;
    for (int num = 1; num < A; ++num) {
        for (int pos = 0; pos <= N - k; ++pos) {
            bool ft = true;
            for (int i = 0; i < N && ft; ++i) {
                if (i < pos) {
                    if (s[i] - '0') ans += (s[i] - '0') * pw[N - pos - k];
                }
                else if (i < pos + k) {
                    if (s[i] - '0' > num) ans += pw[N - pos - k];
                    if (s[i] - '0' != num) ft = false;
                }
                else if (s[i] - '0') ans += (s[i] - '0') * pw[N - i - 1];
            }
            ans += ft;
        }
    }
    return ans;
}

int main()
{
    pw[0] = 1;
    for (int i = 1; i <= N; ++i) pw[i] = pw[i - 1] * A;
    scanf("%d", &t);
    while (t--) {
        scanf("%s%s", l, r);
        int l_len = strlen(l), r_len = strlen(r);
        pr(l, l_len);
        sub1(l);
        pr(r, r_len);
        int k;
        long long ans = 0;
        for (k = N; !ans; --k) {
            long long ansl = get(l, k), ansr = get(r, k);
            ans = ansr - ansl;
        }
        printf("%d %lld\n", k + 1, ans);
        memset(l, 0, 4 * N);
        memset(r, 0, 4 * N);
    }
    return 0;
}
