#include <bits/stdc++.h>

using namespace std;

std::string get_ans(int32_t n, int32_t k) {
    std::string str;
    for(int32_t i = 0; i < (1 << k); i++) {
        for(int32_t j = k - 1; j >= 0; j--) {
            str += i & (1 << j) ? '1': '0';
        }
        if(str.size() >= (1 << n))
            return str;
    }
    return str;
}

int32_t eval(int32_t n, std::string& str, int32_t k) {
    if(str.size() != (1 << n))
        return 0;

    std::set<std::string> all_str;
    for(int32_t len = 1; len < (1 << k); len <<= 1) {
        for(int32_t i = 0; i < n; i += len)
            all_str.insert(str.substr(i, len));
    }

    int32_t ans = all_str.size();
    for(int32_t p = k; p <= n; p *= 2)
        ans += n / p;
    return ans;
}

int main(){
    int32_t n;
    std::cin >> n;

    if(n == 1) {
        std::cout << "10";
        return 0;
    }

    std::string s1 = get_ans(n, 2);
    std::string s2 = get_ans(n, 4);
    std::string s3 = get_ans(n, 8);
    std::string s4 = get_ans(n, 16);

    std::string& ans = s1;
    int32_t best_k = 2;
    if(eval(n, s2, 4) > eval(n, ans, best_k)) {
        ans = s2;
        best_k = 4;
    }
    if(eval(n, s3, 8) > eval(n, ans, best_k)) {
        ans = s3;
        best_k = 8;
    }
    if(eval(n, s4, 16) > eval(n, ans, best_k))
        ans = s4;

    std::cout << ans;
}

