#include <iostream>
#include <vector>
using namespace std;
#define vtype long long int
vector<vtype> read_vec(vtype n) {
    vector<vtype> out(n);
    for (vtype i = 0; i < n; i++) {
        cin >> out[i];
    }
    return out;
}

struct Data {
    vtype val;
    vtype ind;
    vtype arr;
};

Data find_min_ind(vector<vtype> v, vtype a, vtype min_=-1000000001, vtype not_i = -1) {
    vtype ind  = -1;
    vtype min_val = 1000000001;
    for (vtype i = 0; i < v.size(); i++) {
        if (min_ < v[i] && v[i] < min_val && not_i != i && v[i] != 0) {
            min_val = v[i];
            ind = i;
        }
    }
    return {min_val, ind, a};
}


vtype count_of(vector<vtype> v, vtype n) {
    vtype c = 0;
    for (vtype i : v) {
        if (i == n) {
            c++;
        }
    }
    return c;
}

bool task(vtype n, vector<vtype> v1, vector<vtype> v2) {
    bool out = false;

    while (1) {
        auto p1 = find_min_ind(v1, 0, -1000000001);
        auto p2 = find_min_ind(v2, 1, -1000000001, p1.ind);
        if (p1.ind != -1 && p2.ind != -1) {
            //auto p_min = min(p1, p2, comp);
            //auto p_max = max(p1, p2, comp);
            Data p_max;Data p_min;
            if (p1.val > p2.val)
            {
                p_max = p1;
                p_min = p2;
            }
            else if (p1.val == p2.val) {
                p_max = p2;
                p_min = p1;
            }
            else if (p1.val < p2.val) {
                p_max = p2;
                p_min = p1;
            }

            if (p_max.arr == 0) {
                v1[p_max.ind] = p_max.val - p_min.val;
            }
            else {
                v2[p_max.ind] = p_max.val - p_min.val;
            }

            if (p_min.arr == 0) {
                v1[p_min.ind] = 0;
                //v2[p_max.ind] = p_max.val - p_min.val;
            }
            else {
                v2[p_min.ind] = 0;
                //v1[p_max.ind] = p_max.val - p_min.val;
            }
        }
        else {

        }
        if ((v2.size() - count_of(v2, 0)) <= 1) {
            out = true;
            break;
        }
        else if (count_of(v1, 0) == v1.size() ) {
            out = false;
            break;
        }
    }
    return out;
}


int main() {
    vtype n = 0;
    cin >> n;
    for (vtype i = 0; i < n; i++)
    {
        vtype nt;
        cin >> nt;
        vector<vtype> v1 = read_vec(nt);
        vector<vtype> v2 = read_vec(nt);

        if (task(nt, v1, v2))
            cout << "YES\n";
        else
            cout << "NO\n";

    }
    return 0;
}