#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <cmath>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double db;

ll n, k;

vector<vector<ll> >dp;
ll ans = 0;
vector<ll>p, pred;

void res(int sum = n, int mn = 1){
    if(sum < 0){
        return;
    }
    if(sum == 0){
        int cnt = 1, q = 1;
        for(int i = 1; i < p.size(); i++){
            if(p[i] != p[i - 1]){
                q *= pred[cnt];
                cnt = 1;
            }
            else{
                cnt++;
            }
        }
        q *= pred[cnt];
        ans += q;
        return;
    }
    for(int i = mn; i <= n; i++){
        p.push_back(i);
        res(sum - i, max(mn, i));
        p.pop_back();
    }
}

int main() {
    cin >> n >> k;
    dp.resize(16, vector<ll>(k + 1));
    pred.resize(16);
    for(int i = 1; i <= k; i++){
        dp[1][i] = 1;
    }
    for(int i = 2; i <= 15; i++){
        for(int j = 1; j <= k; j++){
            for(int z = j; z <= k; z++){
                dp[i][j] += dp[i - 1][z];
            }
        }
    }
    for(int i = 1; i <= 15; i++){
        for(int j = 1; j <= k; j++){
            pred[i] += dp[i][j];
        }
    }
    res();
    cout << ans;
    return 0;
}
/*
12
abcabcabcabc
*/
