from collections import deque

def main():
    n, m, k = map(int, input().split())
    gr = [[] for i in range(n)]
    sets = [[0 for j in range(k)] for i in range(n)]

    list(map(int, input().split()))

    for _ in range(m):
        u, v = map(int, input().split())
        u -= 1
        v -= 1
        gr[u].append(v)
        gr[v].append(u)

    result = [0] * n

    queue = deque()
    queue.append(0)
    result[0] = 1

    for y in gr[0]:
        sets[y][0] = 1

    while queue:
        elem = queue.popleft()
        for y in gr[elem]:
            if result[y] == 0:
                slava = 0
                for z in range(result[elem], k):
                    if sets[y][z] == 0:
                        slava = z
                        break
                result[y] = slava + 1
                for iterator in gr[y]:
                    sets[iterator][slava] = 1
                queue.append(y)

    print(*result)

if __name__ == "__main__":
    main()
"""
4 4 4
1 2 3 1
1 2 
1 3
2 3
3 4
"""

