#include "bits/stdc++.h"

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef unsigned int uint;
typedef long double ld;

#define PB push_back
#define EB emplace_back
#define S second
#define MT make_tuple
#define MP make_pair
#define len(s) (int)s.size()
ll answer = 0;

ll Fact[16];
ll Cnt[16][16];

ll C(ll n, ll k){
    return Fact[n] / (Fact[k] * Fact[n - k]);
}

ll Count(ll n, ll k){
    if(Cnt[n][k]) return Cnt[n][k];
    if(n == 0) return 1;
    ll sum = 0;
    for(ll i = 1; i <= min(k, n); i++){
        ll val = Count(n - i, i);
        sum += val * C(k, i);
    }
    Cnt[n][k] = sum;
    return sum;
}


void F(ll sum, vector<ll>&nums, ll n, ll k) {
    if (sum == n) {
        vector<ll> cols(16, 0);
        for (auto i : nums) {
            cols[i]++;
        }
        ll cur_p = 1;
        for (auto i : cols) {
            if(i == 0) continue;
            cur_p *= Count(i, k);
        }
        answer += cur_p;
        return;
    }
    ll i = nums[len(nums) - 1];
    while (i + sum <= n) {
        nums.emplace_back(i);
        F(sum + i, nums, n, k);
        nums.pop_back();
        i++;
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ifstream fin("INPUT.TXT");
    ofstream fout("OUTPUT.TXT");
    
    Fact[0] = 1LL;
    for(ll i = 1; i <= 15; i++) Fact[i] = Fact[i - 1] * i;
    ll n, k;
    cin >> n >> k;
    vector<ll>nums;
    for(ll i = 1; i <= n; i++){
        nums.push_back(i);
        F(i, nums, n, k);
        nums.pop_back();
    }
    cout << answer;
    return 0;
}