#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;

template <class T> bool ckmin(T &a,T b){ return a > b? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define F first
#define S second

// const int N = 2e5 + 500;
const int mod = 1e9 + 7; //998244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

bool get_dp(int n, const vi& a, const vi& b) {
    vector<ll> sa(n+1), sb(n+1), dp(n+1);
    for (int i = 0; i < n; ++i) {
        sa[i+1] = sa[i] + a[i];
        sb[i+1] = sb[i] + b[i];

        dp[i+1] = min<ll>(sb[i], a[i] + dp[i]);
        ll lost = max<ll>(0, sa[i] - max<ll>(0, dp[i+1] - a[i]));
        dp[i+1] += min<ll>(b[i], lost);
    }

    return dp.back() == sb[n];
}

bool solve() {
    int n; cin >> n; int tmp;
    vi a(n), b(n);
    for(int& x : a) cin >> x;
    for(int& x : b) cin >> x;
    int j = 0;
    for (int i = 1; i < n; ++i)
        if (a[i] + b[i] > a[j] + b[j]) j = i;
    tmp = b[j]; b[j] = 0;
    bool ok = get_dp(n, a, b);
    b[j] = tmp;
    if (ok) return true;

    for (int i = 0; i < n; ++i)
        if (b[i] > b[j]) j = i;
    tmp = b[j]; b[j] = 0;
    return get_dp(n, a, b);

    // return false;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
    int t; cin >> t; while(t--) cout << (solve() ? "YES" : "NO") << '\n';

    return 0;
}